<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * Ͽ(ϿMobileǤΤ߻)
 */
class BBSB_EditGamedetailMpitAction extends BBSB_AbstractEditAction
{
	var $mPitchScoreList		= array();		// ӥǡ

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/EditGamedetailMpitForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/ViewGameForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbMember.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGamePitcher.class.php";
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_EditGamedetailMpitForm($this->mMyDirName);
		$this->mActionForm->prepare();
		$this->mActionFormCond	= new BBSB_ViewGameForm();
		$this->mActionFormCond->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		$this->mActionFormCond->load($this->mObject);	// եΥ
		$this->mActionFormCond->fetch();				// ꥯȥեफͤμ
		$this->mActionFormCond->validate();				// ͭȽ

		if( xoops_getrequest('gid') ){
			// gidȤ(ϻ)
			$gid		= xoops_getrequest('gid');

			// ǡեǤ˥å
			$this->mActionForm->mFormProperties['gid']->mValue			= $gid;			// GameID

			// GameIDɳդüԥǡ
			$pitchList = array();
			$dbGp	= new BBSB_DbGamePitcher($this->mMyDirName);
			$sqlstr =	" SELECT M.UniformNo,P.* ";
			$sqlstr .=	" FROM " . $dbGp->prefix_dir('bb_gamepitcher') . " P, ";
			$sqlstr .=			$dbGp->prefix_dir('bb_member') . " M ";
			$sqlstr .=  " WHERE P.GameID='" . $gid . "' ";
			$sqlstr	.=	"   AND P.UserID=M.UserID ";
			$sqlstr .=	" ORDER BY P.ChangeCnt ";
			$pitchList = $dbGp->getList( $sqlstr );
			foreach( $pitchList as $key => $dat ){
				$this->mPitchScoreList[$key]['pitcher']		= $dat['UserID'];
				$this->mPitchScoreList[$key]['uniformno']	= $dat['UniformNo'];
				$this->mPitchScoreList[$key]['throwinning']	= $dat['Innings'];
				$this->mPitchScoreList[$key]['throwout']	= $dat['OutCnt'];
				$this->mPitchScoreList[$key]['earnedruns']	= $dat['EarnedRuns'];
				$this->mPitchScoreList[$key]['runs']		= $dat['Runs'];
				$this->mPitchScoreList[$key]['kcnt']		= $dat['KCnt'];
				$this->mPitchScoreList[$key]['bcnt']		= $dat['BCnt'];
				$this->mPitchScoreList[$key]['dbcnt']		= $dat['DBCnt'];
				$this->mPitchScoreList[$key]['hcnt']		= $dat['HCnt'];
				$this->mPitchScoreList[$key]['hrcnt']		= $dat['HRCnt'];
				$this->mPitchScoreList[$key]['numofpitch']	= $dat['NumOfPitch'];
				// ԤȽ
				$this->mPitchScoreList[$key]['pitchresult'] = 0;
				if( $dat['Lose'] ){ $this->mPitchScoreList[$key]['pitchresult'] = 'Lose'; }
				if( $dat['Win']  ){ $this->mPitchScoreList[$key]['pitchresult'] = 'Win'; }
				if( $dat['Save'] ){ $this->mPitchScoreList[$key]['pitchresult'] = 'Save'; }
				if( $dat['Hold'] ){ $this->mPitchScoreList[$key]['pitchresult'] = 'Hold'; }
			}
		} else {
			// gid ̵ȤȤߤʤ
			$controller->executeForward("./index.php" );
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		$this->mActionForm->load($this->mObject);		// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();					// ꥯȥեफͤμ
		$this->mActionFormCond->load($this->mObject);	// եΥ
		$this->mActionFormCond->fetch();				// ꥯȥեफͤμ

		// 󥻥(POSTϤѥ᡼뤿ᡢloadfetchȤ˥󥻥Ƚꤹ)
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->validate();					// ͭͤ
		$this->mActionFormCond->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		$gid = $this->mActionForm->mFormProperties['gid']->mValue;

		// ԥå㡼ơ֥Ͽ(bb_gamepitcer)
		$lP=array();	// ԥå㡼ӥǡ
		$uid		= array();
		$dbM		= new BBSB_DbMember($this->mMyDirName);
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_PITCHERS_ROWNUM ; $rcnt++ ){
			if( $this->mActionForm->mFormProperties['uniformno']->mProperties[$rcnt]->mValue == "" ){continue;}
			$lP[$rcnt]['UniformNo']		= $this->mActionForm->mFormProperties['uniformno']->mProperties[$rcnt]->mValue;
			// UserIDֹ椫
			$dbM->unsetData();
			$dbM->setData( 'UniformNo',	$lP[$rcnt]['UniformNo'] );
			$dbM->setOrderBy( 'UserID', 'ASC' );
			$uid = $dbM->getListbyCond('bb_member','UserID', 1);
			$lP[$rcnt]['UserID']		= $uid[0]['UserID'];
			$lP[$rcnt]['Innings']		= $this->mActionForm->mFormProperties['throwinning']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['OutCnt']		= $this->mActionForm->mFormProperties['throwout']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['EarnedRuns']	= $this->mActionForm->mFormProperties['earnedruns']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['Runs']			= $this->mActionForm->mFormProperties['runs']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['KCnt']			= $this->mActionForm->mFormProperties['kcnt']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['BCnt']			= $this->mActionForm->mFormProperties['bcnt']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['DBCnt']			= $this->mActionForm->mFormProperties['dbcnt']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['HCnt']			= $this->mActionForm->mFormProperties['hcnt']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['HRCnt']			= $this->mActionForm->mFormProperties['hrcnt']->mProperties[$rcnt]->mValue;
			$lP[$rcnt]['NumOfPitch']	= $this->mActionForm->mFormProperties['numofpitch']->mProperties[$rcnt]->mValue;
			switch( $this->mActionForm->mFormProperties['pitchresult']->mProperties[$rcnt]->mValue ){		// (Result)Win/Lose/SaveΤ줫˾ʬϿ
				case 'Lose':
					$lP[$rcnt]['Lose']	= 1;
					break;
				case 'Win':
					$lP[$rcnt]['Win']	= 1;
					break;
				case 'Save':
					$lP[$rcnt]['Save']	= 1;
					break;
				case 'Hold':
					$lP[$rcnt]['Hold']	= 1;
					break;
			}
		}
		$ret = $this->insPitcherData( $gid, $lP );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			return $ret;
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		// Mobileѥƥץ졼(PCѤ̵)
		$render->setTemplateName("bbsb_editgamedetailMpit.html");	// Mobile
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute("actionFormCond",	$this->mActionFormCond);
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_EDITGAMEDETAILMPIT') );	// ̾

		if( xoops_getenv("REQUEST_METHOD") == "POST" ){
			// POSTΥեɽ(=ϼԻν)

			// ǡեफ齦
			for( $rcnt = 0 ; $rcnt < _BBSB_OP_PITCHERS_ROWNUM ; $rcnt++ ){
				// ̾˥󥰿åͿ͵塢Ϳ塢ǡǡ
				$this->mPitchScoreList[$rcnt]['pitcher']		= $this->mActionForm->mFormProperties['pitcher']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['uniformno']		= $this->mActionForm->mFormProperties['uniformno']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['throwinning']	= $this->mActionForm->mFormProperties['throwinning']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['throwout']		= $this->mActionForm->mFormProperties['throwout']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['earnedruns']		= $this->mActionForm->mFormProperties['earnedruns']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['runs']			= $this->mActionForm->mFormProperties['runs']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['kcnt']			= $this->mActionForm->mFormProperties['kcnt']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['bcnt']			= $this->mActionForm->mFormProperties['bcnt']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['dbcnt']			= $this->mActionForm->mFormProperties['dbcnt']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['hcnt']			= $this->mActionForm->mFormProperties['hcnt']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['hrcnt']			= $this->mActionForm->mFormProperties['hrcnt']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['numofpitch']		= $this->mActionForm->mFormProperties['numofpitch']->mProperties[$rcnt]->mValue;
				$this->mPitchScoreList[$rcnt]['pitchresult']	= $this->mActionForm->mFormProperties['pitchresult']->mProperties[$rcnt]->mValue;
			}
		}

		// IDbb_gameơ֥뤫
		$otList = array();
		$dbGm		= new BBSB_DbGame($this->mMyDirName);
		$sqlstr		=	" SELECT OwnTeamID ";
		$sqlstr		.=	" FROM " . $dbGm->prefix_dir('bb_game') ;
		$sqlstr		.=  " WHERE GameID='" . xoops_getrequest('gid') . "' ";
		$otList		= $dbGm->getList( $sqlstr );
		$OwnTeamID	= $otList[0]['OwnTeamID'];

		// Υᥤ̾
		$ownteams		= array();
		$ownteams		= $this->getOwnTeamName();
		$ownteamname	= "";
		foreach( $ownteams as $key => &$team ){
			if( $team['TeamID'] == $OwnTeamID ){
				$ownteamname = $team['TeamName'];
				break;
			}
		}
		$render->setAttribute("ownteamname",	$ownteamname);

		// Ӥեǡ˥å
		$render->setAttribute("pitchscores",	$this->mPitchScoreList);

		// :
		// ӷ̥쥯ȥܥå
		$pitchresultList = array(	'Lose'	=>	_MD_BBSB_LANG_LOSE2,	// 
									'Win'	=>	_MD_BBSB_LANG_WIN,		// 
									'Save'	=>	_MD_BBSB_LANG_SAVE,		// 
									'Hold'	=>	_MD_BBSB_LANG_HOLD);	// ۡ
		$render->setAttribute("pitchresults", $pitchresultList );
	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$gid	= xoops_getrequest('gid');
		$getstr = $this->makeCondStrM();
		$controller->executeForward("./index.php?action=EditGamedetail&gid=" . $gid . $getstr );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν Ͽ̤
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$gid	= xoops_getrequest('gid');
		$getstr = $this->makeCondStrM();
		$controller->executeForward("./index.php?action=EditGamedetail&gid=" . $gid . $getstr );
	}

	/**
	 * Ʋ̤ϤGETѥ᡼
	 */
	function makeCondStrM()
	{
		$getstr	=  "";
		if( $this->mActionFormCond->get('cond_ownteamid')	!== null){
			$getstr .= "&cond_ownteamid="    . $this->mActionFormCond->get('cond_ownteamid');
		}
		if( $this->mActionFormCond->get('cond_nendo')		!== null ){
			$getstr .= "&cond_nendo="        . $this->mActionFormCond->get('cond_nendo');
		}
		if( $this->mActionFormCond->get('cond_month') ){
			$getstr .= "&cond_month="        . $this->mActionFormCond->get('cond_month');
		}
		if( $this->mActionFormCond->get('cond_start') ){
			$getstr .= "&cond_start="        . $this->mActionFormCond->get('cond_start');
		}
		if( $this->mActionFormCond->get('cond_perpage') ){
			$getstr .= "&cond_perpage="      . $this->mActionFormCond->get('cond_perpage');
		}
		return $getstr;
	}

}
?>
