<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * 饦ɾϿ
 */
class BBSB_EditGrounddetailAction extends BBSB_AbstractEditAction
{
	var $mGrList				= null;		// 饦ɥǡ(1ʬ)

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/EditGrounddetailForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGround.class.php";
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_EditGrounddetailForm($this->mMyDirName);
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		if( xoops_getrequest('gid') ){
			// gidȤ(ϻ)
			$gid = xoops_getrequest('gid');

			// gidɳդǡ
			$dbGr = new BBSB_DbGround($this->mMyDirName);
			$dbGr->setData( 'GroundID', $gid );
			$this->mGrList = $dbGr->getListbyCond( 'bb_ground', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

			// 饦ɥǡեǤ˥å
			$this->mActionForm->mFormProperties['gid']->mValue			= $this->mGrList[0]['GroundID'];	// GroundID
			$this->mActionForm->mFormProperties['groundname']->mValue	= $this->mGrList[0]['GroundName'];	// ֥饦̾
			$this->mActionForm->mFormProperties['url']->mValue			= $this->mGrList[0]['Url'];			// URL
			$this->mActionForm->mFormProperties['phoneno']->mValue		= $this->mGrList[0]['PhoneNo'];		// á
			$this->mActionForm->mFormProperties['zipcode']->mValue		= $this->mGrList[0]['ZipCode'];		// ͹ֹ
			$this->mActionForm->mFormProperties['address']->mValue		= $this->mGrList[0]['Address'];		// ֽ
			$this->mActionForm->mFormProperties['comments']->mValue		= $this->mGrList[0]['Comments'];	// ֥ȡ
			$this->mActionForm->mFormProperties['codefield']->mValue	= $this->mGrList[0]['CodeField'];	// ֥
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * 饦ɥǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// 󥻥
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// 饦ɥơ֥Ͽ(bb_ground)
		$dbGr = new BBSB_DbGround($this->mMyDirName);		// 饦ɥǡѤDB󥹥
		$dbGr->setData( 'GroundName',	$this->mActionForm->mFormProperties['groundname']->mValue );
		$dbGr->setData( 'Url',			$this->mActionForm->mFormProperties['url']->mValue );
		$dbGr->setData( 'PhoneNo',		$this->mActionForm->mFormProperties['phoneno']->mValue );
		$dbGr->setData( 'ZipCode',		$this->mActionForm->mFormProperties['zipcode']->mValue );
		$dbGr->setData( 'Address',		$this->mActionForm->mFormProperties['address']->mValue );
		$dbGr->setData( 'Comments',		$this->mActionForm->mFormProperties['comments']->mValue );
		$dbGr->setData( 'CodeField',	$this->mActionForm->mFormProperties['codefield']->mValue );

		// GroundIDȤUPDATE(¸ǡԽ)ʤINSERT()
		if( $this->mActionForm->mFormProperties['gid']->mValue ){
			// ¸ǡԽUPDATE
			$keyarray = array( 'GroundID'=>$this->mActionForm->mFormProperties['gid']->mValue );
			$result = $dbGr->update( 'bb_ground', $keyarray );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			// INSERT
			$result = $dbGr->insert( 'bb_ground' );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_editgrounddetailM.html");
		} else {
			$render->setTemplateName("bbsb_editgrounddetail.html");
			$render->setAttribute("xoops_module_header",	_BBSB_OP_CSSFILE );
		}
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_EDITGROUNDDETAIL') );
	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewGroundlist" );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 饦ɰ
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewGroundlist");
	}

}
?>
