<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/*
 * ưͽ зϿ
 */class BBSB_EditSchedulememberdetailAction extends BBSB_AbstractEditAction
{
	var $mSid	 		= null;		// 塼ID
	var $mScheList		= array();	// 塼ꥹ
	var $mJoinList		= array();	// öʬǡ
	var $mConfig		= null;		// ⥸塼륳ե

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/EditSchedulememberdetailForm.class.php";	// ե९饹
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbSchedule.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbScheduleMember.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbJoinState.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/RegistMailBuilder.class.php";
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditAction#_setupActionForm()
     */
	function _setupActionForm()
	{
		$this->mActionForm = new BBSB_EditSchedulememberdetailForm($this->mMyDirName);
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		$this->mConfig = $moduleConfig;
		// ưͽ굡ǽȤʤϽλ
		if( !_BBSB_OP_DISPSCHE ){
			$controller->executeForward("./index.php");
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ScheduleID̵Ͻλ
		if( !xoops_getrequest('sid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$this->mSid = xoops_getrequest('sid');
		$this->mActionForm->mFormProperties['sid']->mValue			= $this->mSid;							// ֥塼ID

		if( xoops_getrequest('eid') ){
			// EntrantIDȤ(ϻ)
			$eid = xoops_getrequest('eid');

			// eidɳդ塼Хǡ
			$dbSM = new BBSB_DbScheduleMember($this->mMyDirName);
			$dbSM->setData( 'ScheduleID', 	$this->mSid );
			$dbSM->setData( 'EntrantID',	$eid );
			$this->mScheList = $dbSM->getListbyCond( 'bb_schedulemember', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

			// зХǡեǤ˥å(ѥɤ㳰)
			$this->mActionForm->mFormProperties['eid']->mValue			= $this->mScheList[0]['EntrantID'];		// ֽзID
			$this->mActionForm->mFormProperties['name']->mValue			= $this->mScheList[0]['Name'];			// ̾
			$this->mActionForm->mFormProperties['joinstateid']->mValue	= $this->mScheList[0]['JoinStateID'];	// ֻü̡
			$this->mActionForm->mFormProperties['oldjoinstateid']->mValue	= $this->mScheList[0]['JoinStateID'];	// ֻü̡()
			$this->mActionForm->mFormProperties['comments']->mValue		= $this->mScheList[0]['Comments'];		// ֥ȡ
			$this->mActionForm->mFormProperties['updatetime']->mValue	= $this->mScheList[0]['UpdateTime'];	// ֹջ

		} else {
			// eid ̵Ȥ()
			// cookieȤ̾(Ӱʳ)
			if( isset($_COOKIE['bbscoremanageer_ename']) && !$this->mMobile ){
				$this->mActionForm->mFormProperties['name']->mValue = stripslashes($_COOKIE['bbscoremanageer_ename']);
			}
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * 塼ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// ScheduleID̵Ͻλ
		if( !xoops_getrequest('sid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$this->mSid = xoops_getrequest('sid');

		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ

		// 󥻥
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// 塼Хơ֥Ͽ(bb_schedulemember)
		$dbSM = new BBSB_DbScheduleMember($this->mMyDirName);		// 塼ХǡѤDB󥹥
		$dbSM->setData( 'Name',			$this->mActionForm->mFormProperties['name']->mValue );
		$dbSM->setData( 'JoinStateID',	$this->mActionForm->mFormProperties['joinstateid']->mValue );
		$dbSM->setData( 'Comments',		$this->mActionForm->mFormProperties['comments']->mValue );
		if( $this->mActionForm->mFormProperties['pass']->mValue != "" ){
			$pass = md5( $this->mActionForm->mFormProperties['pass']->mValue );
			$dbSM->setData( 'Pass',			$pass );
		}
		$nowstr = 'NOW()';
		$dbSM->setData( 'UpdateTime',	$nowstr );
		// EntrantIDȤUPDATE(¸ǡԽ)ʤINSERT()
		if( $this->mActionForm->mFormProperties['eid']->mValue ){
			// ¸ǡԽUPDATE
			$keyarray = array(	'ScheduleID'=>$this->mActionForm->mFormProperties['sid']->mValue,
								'EntrantID'=>$this->mActionForm->mFormProperties['eid']->mValue );
			$result = $dbSM->update( 'bb_schedulemember', $keyarray );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			// INSERT
			$dbSM->setData( 'ScheduleID',	$this->mActionForm->mFormProperties['sid']->mValue );
			$result = $dbSM->insert( 'bb_schedulemember' );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		// ̾򥯥å¸Ƥ
		setcookie('bbscoremanageer_ename', $this->mActionForm->mFormProperties['name']->mValue, time() + BBSB_COOKIE_KEEP_TIME);
		// ԤΥ᡼
		$this->_processMail($controller);

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	// 
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{

		if( $this->mMobile ){
			$render->setTemplateName("bbsb_editschedulememberdetailM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_editschedulememberdetail.html");
			$render->setAttribute("xoops_module_header",	_BBSB_OP_CSSFILE );
		}
		$render->setAttribute("actionForm", $this->mActionForm);

		// sidɳդ塼ǡ
		$dbSche = new BBSB_DbSchedule($this->mMyDirName);
		$dbSche->setData( 'ScheduleID', $this->mSid );
		$col = "EventKind,EventName,EventYear,EventMonth,EventDay,EventHour,EventMinute";
		$this->mScheList = $dbSche->getListbyCond( 'bb_schedule', $col, _BBSB_LIMIT_1 );
		// ٥ȼ ʸѴ
		$this->mScheList[0]['EventKind'] = $this->getEventKindStr( $this->mScheList[0]['EventKind'] );
		//  ʸѴ
		$this->mScheList[0]['EventDate'] = $this->getDateStr(	$this->mScheList[0]['EventYear'],
																$this->mScheList[0]['EventMonth'],
																$this->mScheList[0]['EventDay'],
																$this->mScheList[0]['EventHour'],
																$this->mScheList[0]['EventMinute'] );
		$render->setAttribute("schelist", $this->mScheList );

		// 
		// зǡ
		$dbJs = new BBSB_DbJoinState($this->mMyDirName);
		$dbJs->setData( 'ScheduleID', $this->mSid );
		$this->mJoinList = $dbJs->getListbyCond('bb_joinstate');
		$render->setAttribute("joinstates", $this->mJoinList );

		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_EDITSCHEDULEMEMBERDETAIL') );
	}

	/**
	 * з繹Υ᡼
	 * @param $controller
	 * @return unknown_type
	 */
	function _processMail(&$controller)
	{
		// Τݥå
		// sidɳդ塼ǡ
		$dbSche = new BBSB_DbSchedule($this->mMyDirName);
		$dbSche->setData( 'ScheduleID', $this->mSid );
		$col = "ScheduleID,Submitter,SubmitterEmail,NoticeEmailFlg,EventKind,EventName,EventYear,EventMonth,EventDay,EventHour,EventMinute";
		$this->mScheList = $dbSche->getListbyCond( 'bb_schedule', $col, _BBSB_LIMIT_1 );
		if( $this->mScheList[0]['NoticeEmailFlg'] && $this->mScheList[0]['SubmitterEmail'] ){	// ΤEmailǼˤƤȤ
			// ٥ȼ ʸѴ
			$this->mScheList[0]['EventKind'] = $this->getEventKindStr( $this->mScheList[0]['EventKind'] );
			//  ʸѴ
			$this->mScheList[0]['EventDate'] = $this->getDateStr(	$this->mScheList[0]['EventYear'],
																	$this->mScheList[0]['EventMonth'],
																	$this->mScheList[0]['EventDay'],
																	$this->mScheList[0]['EventHour'],
																	$this->mScheList[0]['EventMinute'],
																	true );

			// зǡ
			$dbJs = new BBSB_DbJoinState($this->mMyDirName);
			$dbJs->setData( 'ScheduleID', $this->mSid );
			$this->mJoinList = $dbJs->getListbyCond( 'bb_joinstate', "JoinStateID,JoinStateName" );
			$jsary = array();
			foreach( $this->mJoinList as $dat ){
				$key			= $dat['JoinStateID'];
				$jsary[$key]	= $dat['JoinStateName'];
			}
			// Email
			$userlst = array();
			$maillst = explode( ",", $this->mScheList[0]['SubmitterEmail'] );
			foreach( $maillst as $email ){
				$user = new XoopsGuestUser;
				$user->setVar("email", $email);
				$userlst[] = $user;
			}
			// ᡼
			$builder = new BBSB_RegistScheduleEntryNoticeMailBuilder();
			$director = new BBSB_ScheduleEntryNoticeMailDirector($builder, $userlst, $controller->mRoot->mContext->getXoopsConfig(), $this->mConfig);
			$director->contruct( $this->mScheList[0], $this->mActionForm->mFormProperties, $jsary );
			$mailer = $builder->getResult();
			if (!$mailer->send(true)) {
			}	// TODO CHECKS

		}
	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewScheduledetail&sid=" . $this->mSid );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 塼ܺ٤
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewScheduledetail&sid=" . $this->mSid );
	}

}
?>
