<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * 񡦥ȡʥȾϿ
 */
class BBSB_EditTournamentdetailAction extends BBSB_AbstractEditAction
{
	var $mTmList				= null;		// ȡʥȥǡ(1쥳ʬ)

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/EditTournamentdetailForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbTournament.class.php";
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_EditTournamentdetailForm($this->mMyDirName);
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		if( xoops_getrequest('tid') ){
			// tidȤ(ϻ)
			$tid = xoops_getrequest('tid');

			// tidɳդǡ
			$dbTm = new BBSB_DbTournament($this->mMyDirName);
			$dbTm->setData( 'TournamentID', $tid );
			$this->mTmList = $dbTm->getListbyCond( 'bb_tournament', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

			// ȡʥȥǡեǤ˥å
			$this->mActionForm->mFormProperties['tid']->mValue				= $this->mTmList[0]['TournamentID'];	// TournamentID
			$this->mActionForm->mFormProperties['tournamentname']->mValue	= $this->mTmList[0]['TournamentName'];	// ֥ȡʥ̾
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ȡʥȥǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// ¤Τ桼ʳϹԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// 󥻥
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// ȡʥȥơ֥Ͽ(bb_tournament)
		$dbTm = new BBSB_DbTournament($this->mMyDirName);		// ȡʥȥǡѤDB󥹥
		$dbTm->setData( 'TournamentName',	$this->mActionForm->mFormProperties['tournamentname']->mValue );

		// TournamentIDȤUPDATE(¸ǡԽ)ʤINSERT()
		if( $this->mActionForm->mFormProperties['tid']->mValue ){
			// ¸ǡԽUPDATE
			$keyarray = array( 'TournamentID'=>$this->mActionForm->mFormProperties['tid']->mValue );
			$result = $dbTm->update( 'bb_tournament', $keyarray );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		} else {
			// INSERT
			$result = $dbTm->insert( 'bb_tournament' );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_edittournamentdetailM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_edittournamentdetail.html");
			$render->setAttribute("xoops_module_header",	_BBSB_OP_CSSFILE );
		}
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_EDITTOURNAMENTDETAIL') );
	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewTournamentlist" );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν ȡʥȰ
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewTournamentlist");
	}

}
?>
