<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * 饦ɰ
 */
class BBSB_ViewGroundlistAction extends BBSB_AbstractEditAction
{
	var $mDelMsg			= null;			// 쥳ɺå
	var $mGrList			= array();		// 饦ɥǡ
	var $mAdminMode			= null;			// Ը¤Ĥɤ
	var $mPageNavi			= array();		// PageNavi

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGround.class.php";
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$this->mAdminMode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbGr = new BBSB_DbGround($this->mMyDirName);
		// Ƚ
		$sortarray= array( '1'=>'GroundID', '2'=>'GroundName' );
		if( xoops_getrequest('sort') ){
			$sort = xoops_getrequest('sort');
			if( $sort >= 0 ){
				$dir = 'ASC';
			} else {
				$dir = 'DESC';
				$sort = -$sort;
			}
			$dbGr->setOrderBy( $sortarray[$sort], $dir);
		} else {
			// ǥեɽϡ֥饦̾
			$dbGr->setOrderBy( 'GroundName', 'ASC');
		}

		// ڡּ
		if( !xoops_getrequest('cond_start') && !xoops_getrequest('cond_perpage') ){
			// PageNaviѤλ꤬ʤ0ܤ100Լ(PCξ)
			$startrow	= 0;
			$perpage	= $this->mMobile? _BBSB_PAGENAVI_PERPAGE_M : _BBSB_PAGENAVI_PERPAGE;
		} else {
			$startrow	= intval(xoops_getrequest('cond_start'));
			$perpage	= xoops_getrequest('cond_perpage');
		}
		$lstr = $startrow . "," . $perpage;

		// ȯ
		$this->mGrList = $dbGr->getListbyCond('bb_ground', " SQL_CALC_FOUND_ROWS GroundID,GroundName,Url", $lstr );
		if( $this->mGrList === false ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// ׷
		$cnum = $dbGr->getList( "SELECT FOUND_ROWS() AS CNT" );

		// pagenavi
		$ustr = _BBSB_MODULE_URL . "index.php?action=ViewGroundlist";
		if( xoops_getrequest('sort')		){ $ustr .= "&sort="			. xoops_getrequest('sort'); }
		$ustr .= "&cond_perpage=" . $perpage;
		$this->mPageNavi = $this->setPageNavi( $startrow, $perpage, $cnum[0]['CNT'], $ustr  );

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewgroundlistM.html");
		} else {
			$render->setTemplateName("bbsb_viewgroundlist.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);
		}

		$render->setAttribute('delmsg',			$this->mDelMsg);		// å
		$render->setAttribute("grlist",			$this->mGrList);		// 饦ɾ
		$render->setAttribute('pagenavi',		$this->mPageNavi );		// ڡʥӾ
		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_GROUND') );
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

}
?>