<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * ưͽܺɽ
 */
class BBSB_ViewScheduledetailAction extends BBSB_AbstractEditAction
{
	var $mSid					= null;		// 塼ID
	var $mScheList				= array();	// 塼ǡ(1쥳ʬ)
	var $mJsList				= array();	// зǡ
	var $mMemList				= array();	// зХǡ
	var $mDelMsg				= null;		// 쥳ɺå
	var $mNoticeMsg				= null;		// եå
	var $mAdminMode				= null;		// Ը¤Ĥɤ

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbSchedule.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbScheduleMember.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbJoinState.class.php";
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ưͽ굡ǽȤʤϽλ
		if( !_BBSB_OP_DISPSCHE ){
			$controller->executeForward("./index.php");
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// sidɬ
		if( !xoops_getrequest('sid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$this->mSid = xoops_getrequest('sid');

		// Ը¤̵ͭ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}

		// delϺ⡼()
		if( xoops_getrequest('del') ){
			if( !$this->mAdminMode ){
				$controller->executeForward(XOOPS_URL . '/');
			}
			$this->mDelMsg = _MD_BBSB_INFO_DELCONFIRM;
		}
		// cookieϡԽѥ桼쥯ȥܥåѤEntrantID򥻥åȤ
		if( isset($_COOKIE['bbscoremanageer_eid']) ){
			$_POST['eid']= $_COOKIE['bbscoremanageer_eid'];
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// 󥻥
		if( xoops_getrequest('back') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		// ⡼ɥå
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$this->mAdminMode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}

		// ¤ʤΥ桼зǡԽȤ
		if( xoops_getrequest('edit') ){
			// ѥɥå
			$this->mSid = xoops_getrequest('sid');
			$dbSm = new BBSB_DbScheduleMember($this->mMyDirName);
			$pass = xoops_getrequest('pass');
			if( $pass=="" ||	strlen($pass) > 32 ){
				$this->mNoticeMsg = _MD_BBSB_CAUTION_INVALIDPASS;
				return BBSB_FRAME_VIEW_INDEX;
			}
			$vpass = md5($pass);
			$eid = xoops_getrequest('eid');
			$dbSm->setData( 'ScheduleID', $this->mSid );
			$dbSm->setData( 'EntrantID', $eid );
			$plist = $dbSm->getListbyCond( 'bb_schedulemember', 'Pass', _BBSB_LIMIT_1 );
			if( $plist===false || $plist[0]['Pass'] === null || strcmp($plist[0]['Pass'],$vpass)!=0 ){
				$this->mNoticeMsg = _MD_BBSB_CAUTION_INVALIDPASS;
				return BBSB_FRAME_VIEW_INDEX;
			}
			setcookie('bbscoremanageer_eid', $eid, time() + BBSB_COOKIE_KEEP_TIME);
			$controller->executeForward("./index.php?action=EditSchedulememberdetail" . "&sid=" . xoops_getrequest('sid') . "&eid=" . xoops_getrequest('eid') );
		}

		// 嵭ʳξϡֺפΤ

		// delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// delϺ⡼()
		if( !$this->mAdminMode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		if( xoops_getrequest('sid') ){
			// sidꡢdel⤢ => зƤκΤȤ
			$this->mSid = xoops_getrequest('sid');
			$eid = xoops_getrequest('del');

			// ͽХơ֥
			$dbSm = new BBSB_DbScheduleMember($this->mMyDirName);
			$dbSm->unsetData();
			$dbSm->setData( 'ScheduleID', $this->mSid );
			$dbSm->setData( 'EntrantID', $eid );
			$ret = $dbSm->delete( 'bb_schedulemember' );

			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG

			return BBSB_FRAME_VIEW_INDEX;

		} else {
			// 塼뼫ΤκΤȤ

			$this->mSid = xoops_getrequest('del');

			// 塼ơ֥
			$dbSc = new BBSB_DbSchedule($this->mMyDirName);
			$dbSc->unsetData();
			$dbSc->setData( 'ScheduleID',	$this->mSid );
			$ret = $dbSc->delete('bb_schedule');

			// зơ֥
			$dbJs = new BBSB_DbJoinState($this->mMyDirName);
			$dbJs->unsetData();
			$dbJs->setData( 'ScheduleID', $this->mSid );
			$ret = $dbJs->delete( 'bb_joinstate' );

			// ͽХơ֥
			$dbSm = new BBSB_DbScheduleMember($this->mMyDirName);
			$dbSm->unsetData();
			$dbSm->setData( 'ScheduleID', $this->mSid );
			$ret = $dbSm->delete( 'bb_schedulemember' );

		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * 塼ǡɽؿ
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewscheduledetailM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_viewscheduledetail.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE . _BBSB_OP_BBSB_COMMON_JS . _BBSB_OP_SORTTABLE_JS);
		}
		$render->setAttribute("delmsg",			$this->mDelMsg );		// å
		$render->setAttribute("noticemsg",			$this->mNoticeMsg );	// å
		$render->setAttribute("adminmode",		$this->mAdminMode );		// ԥ⡼

		// sidɳդ塼ǡ
		$dbSche = new BBSB_DbSchedule($this->mMyDirName);
		$sqlstr =	" SELECT ScheduleID,EventName,EventYear,EventMonth,EventDay,EventHour,EventMinute,";
		$sqlstr .=	"Submitter,SubmitterEmail,DispEmailFlg,NoticeEmailFlg,GuideComment,UpdateTime,EventKind,MapEmbedFlg,";
		$sqlstr .=	" CASE WHEN Opponent1='0' THEN '" . _BBSB_OP_OWNTEAMNAME1 . "' ELSE O1.TeamName END AS OpponentName1, ";
		$sqlstr .=	" CASE WHEN Opponent2='0' THEN '" . _BBSB_OP_OWNTEAMNAME1 . "' ELSE O2.TeamName END AS OpponentName2, ";
		$sqlstr .=	" CASE WHEN Opponent3='0' THEN '" . _BBSB_OP_OWNTEAMNAME1 . "' ELSE O3.TeamName END AS OpponentName3, ";
		$sqlstr .=	" GR.GroundName,T.TournamentName, ";
		$sqlstr .= 	" GR.Url AS GURL,CodeField,O1.Url AS O1URL,O2.Url AS O2URL,O3.Url AS O3URL ";
		$sqlstr .=	" FROM " . $dbSche->prefix_dir('bb_schedule') . " S ";
		$sqlstr .=	" LEFT JOIN " . $dbSche->prefix_dir('bb_tournament') . " T  ON S.TournamentID=T.TournamentID ";
		$sqlstr .=	" LEFT JOIN " . $dbSche->prefix_dir('bb_ground')     . " GR ON S.GroundID=GR.GroundID ";
		$sqlstr .=	" LEFT JOIN " . $dbSche->prefix_dir('bb_opponent')   . " O1 ON S.Opponent1=O1.TeamID ";
		$sqlstr .=	" LEFT JOIN " . $dbSche->prefix_dir('bb_opponent')   . " O2 ON S.Opponent2=O2.TeamID ";
		$sqlstr .=	" LEFT JOIN " . $dbSche->prefix_dir('bb_opponent')   . " O3 ON S.Opponent3=O3.TeamID ";
		$sqlstr .=	" WHERE ScheduleID='" . $this->mSid . "' ";
		$sqlstr .=	" LIMIT 1 ";
		$this->mScheList = $dbSche->getList( $sqlstr );

		// ǡ
		if( $this->mScheList ){
			// ٥ȼ
			$ekarray = array( 	0=>"",
							1=> _MD_BBSB_LANG_GAME,		// 
							2=> _MD_BBSB_LANG_PRACTICE,	// 
							3=> _MD_BBSB_LANG_SETC		// ¾
			);
			$eknum = $this->mScheList[0]['EventKind'];
			$this->mScheList[0]['EventKind'] = $ekarray[$eknum];

			// ʸ
			$this->mScheList[0]['EventDate'] = $this->getDateStr( $this->mScheList[0]['EventYear'],
																$this->mScheList[0]['EventMonth'],
																$this->mScheList[0]['EventDay'],
																$this->mScheList[0]['EventHour'],
																$this->mScheList[0]['EventMinute']	);
		}

		// з祵ޥ
		$dbSm = new BBSB_DbScheduleMember($this->mMyDirName);
		$sqlstr =	" SELECT J.JoinStateName,COUNT( SM.JoinStateID ) AS COUNT ";
		$sqlstr .=	" FROM " . $dbSm->prefix_dir('bb_joinstate') . " J LEFT JOIN ". $dbSm->prefix_dir('bb_schedulemember') . " SM " ;
		$sqlstr .=	"    ON J.ScheduleID=SM.ScheduleID ";
		$sqlstr .=	"   AND J.JoinStateID=SM.JoinStateID ";
		$sqlstr .=	" WHERE J.ScheduleID='" . $this->mSid . "' ";
		$sqlstr .=	" GROUP BY J.JoinStateID ";
		$sqlstr .=	" ORDER BY J.JoinStateID ";
		$this->mJsList = $dbSm->getList( $sqlstr );
		// դĹ򥻥åȤ
		foreach( $this->mJsList as $key => &$dat ){
			$dat['wid'] = $dat['COUNT'] * 10;
		}

		// зХǡ
		$sqlstr =	" SELECT EntrantID,Name,Comments,UpdateTime,J.JoinStateName,J.Section ";
		$sqlstr .=	" FROM " . $dbSm->prefix_dir('bb_schedulemember') . " SM, " . $dbSm->prefix_dir('bb_joinstate') . " J ";
		$sqlstr .=	" WHERE SM.ScheduleID='" . $this->mSid . "' ";
		$sqlstr .=	"   AND SM.ScheduleID=J.ScheduleID ";
		$sqlstr .=	"   AND SM.JoinStateID=J.JoinStateID ";
		$this->mMemList = $dbSm->getList( $sqlstr );

		$render->setAttribute("schelist",		$this->mScheList );		// 塼
		$render->setAttribute("jslist",			$this->mJsList );		// ǡ
		$render->setAttribute("memlist",		$this->mMemList );		// Хǡ

		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_VIEWSCHEDULEDETAIL') );
	}

	/**
	 * ΤȤ̤
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$year	= xoops_getrequest('year');
		if( $year ){
			$year = "&year=" . $year;
		}
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewSchedulelist" . $year . $del );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 塼
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$year	= xoops_getrequest('year');
		if( $year ){
			$year = "&year=" . $year;
		}
		$controller->executeForward("./index.php?action=ViewSchedulelist" . $year );
	}

}
?>
