<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/*
 * ԡǿ⥸塼γǧ
 */
class BBSB_CheckVersionAction extends BBSB_AbstractEditAction
{
	var $mErrMsg			= null;		// 顼å
	var $mServerSetting		= array();	// setting.ini(ӥ߾֡⡼(zip/auto))
	var $mModuleInfo		= array();	// ⥸塼(ɽ)
	var $mFileOwner			= null;		// ե륪ʡ
	var $mVlog				= null;		// ɥ

	function __construct($mydirname, $flag){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/admin/forms/AdminCheckVersionForm.class.php";	// ե९饹
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/FTP.class.php";							// FTP饹
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/Log.class.php";							// LOG饹
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_CheckVersionForm($this->mMyDirName);
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Log
		$this->mVlog	= new BBSB_LOG();

		// FileOwner(FTP桼) ⥸塼롼Ȥindex.php Υʡɽ롣
		$userinfo = posix_getpwuid(fileowner(_BBSB_MODULE_PATH . "index.php"));
		$this->mFileOwner = $userinfo['name'];
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// Auto⡼ɤZIP⡼ɤwsrsudo¹ԤƤߤȽǤ롣(safemodeΤȤ)
		if ( ini_get('safe_mode') ) {
			$str = $out = "";
			$cmd = _BBSB_OP_UPDATESHELL . " chk";
			$str = exec( $cmd, $out, $ret );
		} else {
			$ret = 1;
			if( file_exists(_BBSB_OP_UPDATESHELL) ){
				$ret = 0;
			}
		}
		if( $ret == 0 ){
			// ưåץǡȥ⡼
			$inifile = _BBSB_OP_UPDATESETTINGAUTO;
			$this->mModuleInfo['mode']			= "auto";
		} else {
			// ZIPɥ⡼
			$inifile = _BBSB_OP_UPDATESETTINGZIP;
			$this->mModuleInfo['mode']			= "zip";
		}

		// FTPؿȤʤϥС󥢥å׵ǽȤʤ
		if( !function_exists('ftp_connect') ){
			$this->mModuleInfo['service']		= "off";
			$this->mModuleInfo['version']		= "";
			$this->mModuleInfo['path']			= "";
			$this->mModuleInfo['rereasenote']	= "";
			return BBSB_FRAME_VIEW_INDEX;
		}

		// FTPС³ǿС
		$cFTP = new BBSB_FTP();		// FTP󥹥

		$ret = $cFTP->connect( _BBSB_OP_FTPUSER, $this->mFileOwner );		// anonymous ѥFileOwner(=FTPuser̾)
		if( $ret == false ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FTPERROR . ":Connect or Login ERROR");
			return BBSB_FRAME_VIEW_INDEX;
		}

		// ե(С󡢥ѥξ)
		$this->mServerSetting = $cFTP->getSetting( $this->mActionForm, $inifile );
		if( $this->mServerSetting === false ){
			$this->mActionForm->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_FTPSETTING, "uploads"));
			return BBSB_FRAME_VIEW_INDEX;
		}

		// FTP ȥ꡼Ĥ
		$cFTP->close();
		unlink(_BBSB_MODULE_UPLOAD_IMAGE_PATH . $inifile);		// ե

		// ӥ椫ɤ
		if( _BBSB_OP_FORCEUPDATE || $this->mModuleInfo['mode']=="zip" ){		// ⡼桢ZIP⡼ɤΤȤϥӥON/OFF̵뤹
			$this->mModuleInfo['service'] = "on";
		} else {
			$this->mModuleInfo['service'] = strtolower($this->mServerSetting['service']);
		}
		$this->mModuleInfo['version']		= $this->mServerSetting['version'];
		$this->mModuleInfo['path']			= $this->mServerSetting['path'];
		$this->mModuleInfo['rereasenote']	= $this->mServerSetting['rereasenote'];

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * AutoUpdate¹
	 * @see modules/webscorerevolution/class/BBSB_AbstractEditAction#execute($controller, $xoopsUser)
	 */
	function execute( &$controller, &$xoopsUser )
	{
		$this->mActionForm->load($this->mObject);	// ǡ
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		// FTPС³
		$cFTP = new BBSB_FTP();
		$ret = $cFTP->connect( _BBSB_OP_FTPUSER, $this->mFileOwner );		// ͥȡ
		if( !$ret ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FTPERROR . ":Connect or Login ERROR");
			return BBSB_FRAME_VIEW_INDEX;
		}

		// AutoUpdateե
		$this->mServerSetting = $cFTP->getSetting( $this->mActionForm, _BBSB_OP_UPDATESETTINGAUTO );
		if( $this->mServerSetting === false ){
			$this->mActionForm->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_FTPSETTING, "uploads"));
			return BBSB_FRAME_VIEW_INDEX;
		}
		if( !_BBSB_OP_FORCEUPDATE && strtolower($this->mServerSetting['service']) != "on" ){
			$this->mActionForm->addErrorMessage(_AD_BBSB_ADMENU_UM_MSG_NOTSERVICE);
			$this->mModuleInfo['version']		= $this->mServerSetting['version'];
			return BBSB_FRAME_VIEW_INDEX;
		}

		$ret = $cFTP->chdir($this->mServerSetting['path']);	// FTP autoupdate ѤΥǥ쥯ȥ˰ư
		if( !$ret ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_FTPPATH . ":" . $this->mServerSetting['path'] );
			return BBSB_FRAME_VIEW_INDEX;
		}

		// httpdμ¹ԥʡ̾(setting.iniΥեowner)
		$huinfo = posix_getpwuid(fileowner(_BBSB_MODULE_UPLOAD_IMAGE_PATH . _BBSB_OP_UPDATESETTINGAUTO));
		$httpduser = $huinfo['name'];

		// Υե֤(uploads/autoupdateذư
		chdir(_BBSB_MODULE_UPLOAD_IMAGE_PATH);
		if( !is_dir(_BBSB_OP_SRCTMPDIR) ){	// autoupdate
			umask(0);
			$ret = mkdir(_BBSB_OP_SRCTMPDIR, 0777 );
			if( !$ret ){
				$this->mActionForm->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_MKDIR, "uploads"));
				$this->mVlog->versionuplog("ERROR:mkdir " . _BBSB_OP_SRCTMPDIR);
				rmdir(_BBSB_OP_SRCTMPDIR);
				return BBSB_FRAME_VIEW_INDEX;
			}
			$this->mVlog->versionuplog("[sh] mkdir " . _BBSB_OP_SRCTMPDIR);

			// ǥ쥯ȥΥʡѹ
			$str = $out = "";
			$cmd = _BBSB_OP_UPDATESHELL . " chown " . $httpduser . " " . $this->mFileOwner . " " . _BBSB_MODULE_UPLOAD_IMAGE_PATH . _BBSB_OP_SRCTMPDIR;
			$str = exec( $cmd, $out, $ret );
			$this->mVlog->versionuplog("[sh] " . $cmd);
			$this->mVlog->versionuplog($out);
			$this->mVlog->versionuplog("[sh] ret=" . $ret);
			if( $ret ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_CHOWN . ":" . $httpduser . " to " . $this->mFileOwner . ":[" . _BBSB_OP_SRCTMPDIR . "]" );
				rmdir(_BBSB_OP_SRCTMPDIR);
				return BBSB_FRAME_VIEW_INDEX;
			}
		}
		chdir(_BBSB_OP_SRCTMPDIR);

		// FTP Ǻǿե
		$ret = $cFTP->syncFiles( $this->mActionForm, $httpduser, $this->mFileOwner, ".", $this->mVlog );
		if( !$ret ){
			return BBSB_FRAME_VIEW_INDEX;
		}

		// FTP ȥ꡼Ĥ
		$cFTP->close();
		// ե륳ԡ
		$srcdir = _BBSB_MODULE_UPLOAD_IMAGE_PATH . _BBSB_OP_SRCTMPDIR . "/";
		$handle = opendir( $srcdir );	// uploads/autoupdate ץ
		if( !$handle ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_DIRNOTFOUND . ":[" . $srcdir . "]" );
			return BBSB_FRAME_VIEW_INDEX;
		}
		while (false !== ($file = readdir($handle))) {
			if ($file == '.' || $file == '..'){
				continue;
			}
			// ԡ
			$str = $out = "";
			$cmd = _BBSB_OP_UPDATESHELL . " cp " . $this->mFileOwner . " " . $srcdir . $file . " " . XOOPS_ROOT_PATH ;
			$str = exec( $cmd, $out, $ret );
			$this->mVlog->versionuplog("[sh] " . $cmd);
			$this->mVlog->versionuplog($out);
			$this->mVlog->versionuplog("[sh] ret=" . $ret);
			if( $ret ){
				$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_CP . ":owner=[" . $this->mFileOwner . "], file=[" . $file . "]");
				return BBSB_FRAME_VIEW_INDEX;
			}
		}
		closedir($handle);

		// ե
		$str = $out = "";
		$cmd = _BBSB_OP_UPDATESHELL . " rm " . $this->mFileOwner . " " . $srcdir;
		$str = exec( $cmd, $out, $ret );
		$this->mVlog->versionuplog("[sh] " . $cmd);
		$this->mVlog->versionuplog($out);
		$this->mVlog->versionuplog("[sh] ret=" . $ret);
		if( $ret ){
			$this->mActionForm->addErrorMessage( _MD_BBSB_ERROR_RM . ":[" . _BBSB_OP_SRCTMPDIR . "]");
			return BBSB_FRAME_VIEW_INDEX;
		}
		unlink(_BBSB_OP_VERUPLOGFILE);											// ե
		unlink(_BBSB_MODULE_UPLOAD_IMAGE_PATH . _BBSB_OP_UPDATESETTINGAUTO);		// ե

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ӥ塼
	 */
	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("admin_checkversion.html");
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute("moduleinfo",	$this->mModuleInfo);
		$render->setAttribute("modname",	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute("submenu",	constant($this->mConstPref . '_ADMENU_UPDATEMODULE') );
		$render->setAttribute("mydirname",	$this->mMyDirName );
	}

	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * եɽAutoUpdateإ쥯
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=AutoUpdate&dirname=" . $this->mMyDirName . "&update=yes");
	}

	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
	}

	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
	}
}
?>
