<?php
// åץǡ

if (!defined('XOOPS_ROOT_PATH')) exit();
global $mydirname;
$mydirname = basename(dirname(dirname(dirname(__FILE__))));

require_once XOOPS_LEGACY_PATH . "/admin/class/ModuleUpdater.class.php";							// Legacy ⥸塼륢åץǡȥ饹
require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbMember.class.php";
require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGame.class.php";

class webscorerevolution_WsrUpdater extends Legacy_ModulePhasedUpgrader
{
	var	$mDirName		= null;		// dirname
	var $mMid			= null;		// ModuleID
	var $mVersion		= null;		// åץǡС
	var $mUpdVersion	= null;		// åץǡȸС

	function __construct()
	{
		global $mydirname;
		$this->mDirName = $mydirname;
		$module_handler =& xoops_gethandler('module');
		$module			= $module_handler->getByDirname($this->mDirName);
		$this->mMid		= $module->getVar('mid');
		$this->mVersion	= $module->getVar('version');

		parent::Legacy_ModulePhasedUpgrader();
	}

	function executeUpgrade(){

		// V1.31 -> V2.0 xoops_configconf_titleconf_descΥĹѹ
		if( $this->mVersion < 200 ){
			$ret = $this->chg_V200_config_colchg();
			if( $ret === false ){
				return false;
			}
		}


		// ƥ饹call - XOOPSåץǡȽ
		parent::executeUpgrade();
		$module_handler =& xoops_gethandler('module');
		$module			=& $module_handler->getByDirname($this->mDirName);
		$this->mUpdVersion	= $module->getVar('version');

		// V1.22 -> V1.31 bb_memberUniformNoINTVARCHAR(8)ѹ
		if( $this->mVersion < 131 ){
			$this->chg_V130_UniformNo_int2vc8();
		}

		// V1.31 -> V2.0  ʣ⥸塼б
		$teamname = null;
		if( $this->mVersion < 200 ){
			$teamname = $this->chg_V200_duplicatable();
		}

		return true;
	}

	/*
	 * V1.31 -> V2.0  ʣ⥸塼б
	 */
	function chg_V200_duplicatable(){
		$dbGm = new BBSB_DbGame($this->mDirName);

		// ơ֥̾ѹ
		$baseTblLst = array(
			'bb_gamebatter',
			'bb_gameentrant',
			'bb_game',
			'bb_schedule',
			'bb_schedulemember',
			'bb_gameorder',
			'bb_ground',
			'bb_joinstate',
			'bb_league',
			'bb_member',
			'bb_gamepitcher',
			'bb_scoremark',
			'bb_tournament',
			'bb_opponent'
		);
		$sqlstr = "SHOW TABLES LIKE '%bb_%'";
		$dbTblLst = $dbGm->getList($sqlstr);
		foreach( $baseTblLst as $table ){
			for( $iCnt=0 ; $iCnt<count($dbTblLst) ; $iCnt++ ){
				if( in_array( $dbGm->mDb->prefix($table), $dbTblLst[$iCnt] ) ){
					$sqlstr = "ALTER TABLE " . $dbGm->mDb->prefix($table) . " RENAME " . $dbGm->prefix_dir($table);
					$result = $dbGm->execute($sqlstr);
					if( $result===false ){
						$this->mLog->addError('Update Error: Alter Table failed.  TABLE=[' . $dbGm->mDb->prefix($table) . '] To [' . $dbGm->prefix_dir($table) . ']' );
						$this->_processReport();
						return false;
					}
					break;
				}
			}
		}

		// newblocksơ֥ˤblockoptionѹ dirname + '|'ƥץͤƬˤĤ
		$blockhtmlLst = array(
			array( 'html'=>'bbsb_block_recentschedule.html',	'itemcnt'=>1 ),	// ֥åhtmlե, ץ
			array( 'html'=>'bbsb_block_recentgame.html',		'itemcnt'=>2 )
		);
		foreach( $blockhtmlLst as $block ){
			$sqlstr = "SELECT options FROM " . $dbGm->mDb->prefix('newblocks') . " WHERE mid='" . $this->mMid . "' AND template='" . $block['html'] . "'";
			$options = $dbGm->getList($sqlstr);
			if( $options ){
				if( substr_count($options[0]['options'], '|') == $block['itemcnt']-1 ){
					$newoption = $this->mDirName . '|' . $options[0]['options'];
					$sqlstr = "UPDATE " . $dbGm->mDb->prefix('newblocks') . " SET options='" . $newoption . "' WHERE mid='" . $this->mMid . "' AND template='" . $block['html'] . "'";
					$result = $dbGm->execute( $sqlstr );
					if( $result===false ){
						$this->mLog->addError('Update Error: sql=[' . $sqlstr . ']' );
						$this->_processReport();
						return false;
					}
				}
			}
		}

		// configơ֥롧bbsb_ownteamname̾ѹ
		// bbsb_ownteamname  bbsb_ownteamname1 ˤ뤿β̾¸롣
		$sqlstr = "SELECT conf_value FROM " . $dbGm->mDb->prefix('config')
				. " WHERE conf_modid='" . $this->mMid . "' AND conf_name='bbsb_ownteamname'";
		$ownteamname = $dbGm->getList($sqlstr);
		// bbsb_ownteamname ̾ΤǤϥ̾bbsb_ownteamname1˥ԡƸŤbbsb_ownteamname쥳ɤ
		if( $ownteamname ){
			$sqlstr = "UPDATE " . $dbGm->mDb->prefix('config') . " SET conf_value='" . $ownteamname[0]['conf_value']
					. "' WHERE conf_modid='" . $this->mMid . "' AND conf_name='bbsb_ownteamname1'";
			$result = $dbGm->execute( $sqlstr );
			if( $result===false ){
				$this->mLog->addError('Update Error: sql=[' . $sqlstr . ']' );
				$this->_processReport();
				return false;
			}
		}

		// configơ֥conf_title̾ΤŤϿ̾Τѹ롣
		// 㡧_MI_BBSB_CFG_REGURATION_T  _MI_WEBSCOREREVOLUTION_CFG_REGURATION_T
		$itemLst = array(
			'CFG_INNINGS_T' ,
			'CFG_INNINGS_D' ,
			'CFG_ENTRYINNINGS_T' ,
			'CFG_ENTRYINNINGS_D' ,
			'CFG_DISPINNINGS_T' ,
			'CFG_DISPINNINGS_D' ,
			'CFG_STARTYEAR_T',
			'CFG_STARTYEAR_D',
			'CFG_OWNTEAMNAME_T' ,
			'CFG_REGURATION_T' ,
			'CFG_REGURATION_D' ,
			'CFG_PREGURATION_T' ,
			'CFG_PREGURATION_D' ,
			'CFG_NAMEDISP_T' ,
			'CFG_NAMEDISP_D' ,
			'CFG_DISPSCORE_T' ,
			'CFG_DISPSCORE_D' ,
			'CFG_DISPSCHE_T' ,
			'CFG_DISPSCHE_D' ,
			'CFG_SCHECAPTCHA_T' ,
			'CFG_SCHECAPTCHA_D'
		);
		$ItemSuffix = '_MI_' . strtoupper($this->mDirName) . '_';
		foreach( $itemLst as $item ){
			$sqlstr = "SELECT conf_title FROM " . $dbGm->mDb->prefix('config')
					. " WHERE conf_modid='" . $this->mMid . "' AND conf_title='_MI_BBSB_" . $item . "'";
			$record = $dbGm->getList($sqlstr);
			if( $record ){
				$sqlstr = "UPDATE " . $dbGm->mDb->prefix('config') . " SET conf_title='" . $ItemSuffix . $item
						. "' WHERE conf_modid='" . $this->mMid . "' AND conf_title='_MI_BBSB_" . $item . "'";
				$result = $dbGm->execute( $sqlstr );
				if( $result===false ){
					$this->mLog->addError('Update Error: sql=[' . $sqlstr . ']' );
					$this->_processReport();
					return false;
				}
			}
		}

		// bb_gameơ֥ѹ:OwnTeamID (SMALLINT)
		$sqlstr	= "DESCRIBE " . $dbGm->prefix_dir('bb_game') . " OwnTeamID";
		$lst	= $dbGm->getList($sqlstr);
		if( !$lst ){
			$sqlstr = "ALTER TABLE " . $dbGm->prefix_dir('bb_game') . " ADD OwnTeamID SMALLINT NULL AFTER Nendo";
			$result = $dbGm->execute($sqlstr);
			if( $result===false ){
				$this->mLog->addError('ALTER TABLE Error: COLUMN ADD failed. COLUMN=[OwnTeamID]');
				$this->_processReport();
				return false;
			}
		}

		// °ѹTeamID, FirstTeamID, LastTeamID UNSIGNED  SIGNED
		$execSqlLst = array(
			array(	'selsql'=>"DESCRIBE "    . $dbGm->prefix_dir('bb_game') . " FirstTeamID",
					'chgsql'=>"ALTER TABLE " . $dbGm->prefix_dir('bb_game') . " CHANGE FirstTeamID FirstTeamID SMALLINT NULL DEFAULT NULL"
				),
			array(	'selsql'=>"DESCRIBE "    . $dbGm->prefix_dir('bb_game') . " LastTeamID",
					'chgsql'=>"ALTER TABLE " . $dbGm->prefix_dir('bb_game') . " CHANGE LastTeamID LastTeamID SMALLINT NULL DEFAULT NULL"
				),
			array(	'selsql'=>"DESCRIBE "    . $dbGm->prefix_dir('bb_opponent') . " TeamID",
					'chgsql'=>"ALTER TABLE " . $dbGm->prefix_dir('bb_opponent') . " CHANGE TeamID TeamID SMALLINT NOT NULL AUTO_INCREMENT"
				)
		);
		foreach( $execSqlLst as $sqlstr ){
			$lst	= $dbGm->getList($sqlstr['selsql']);
			if( $lst && strpos($lst[0]['Type'],'unsigned')!==false ){
				$result = $dbGm->execute($sqlstr['chgsql']);
				if( $result===false ){
					$this->mLog->addError('ALTER TABLE Error: COLUMN CHANGE failed. SQL=[' . $sqlstr['chgsql'] . ']');
					$this->_processReport();
					return false;
				}
			}
		}

		//  ѻߡSendedLeagueID1,L1UpdTime,SendedLeagueID2,L2UpdTime,SendedLeagueID3,L3UpdTime
		$sqlstr	= "DESCRIBE " . $dbGm->prefix_dir('bb_game') . " SendedLeagueID1";
		$lst	= $dbGm->getList($sqlstr);
		if( $lst ){
			$sqlstr = "ALTER TABLE " . $dbGm->prefix_dir('bb_game') . " DROP SendedLeagueID1, DROP L1UpdTime, DROP SendedLeagueID2, DROP L2UpdTime, DROP SendedLeagueID3, DROP L3UpdTime";
			$result = $dbGm->execute($sqlstr);
			if( $result===false ){
				$this->mLog->addError('ALTER TABLE Error: COLUMN DROP failed. COLUMN=[SendedLeagueID1,...]');
				$this->_processReport();
				return false;
			}
		}

		//  ѹOwnTeamID,FirstTeamID,LastTeamID 0Υ쥳ɤ'-1'
		$execSqlLst = array(
			"UPDATE " . $dbGm->prefix_dir('bb_game') . " SET OwnTeamID='-1'   WHERE OwnTeamID is NULL",
			"UPDATE " . $dbGm->prefix_dir('bb_game') . " SET FirstTeamID='-1' WHERE FirstTeamID='0'",
			"UPDATE " . $dbGm->prefix_dir('bb_game') . " SET LastTeamID='-1'  WHERE LastTeamID='0'"
		);
		foreach( $execSqlLst as $sqlstr ){
			$result = $dbGm->execute($sqlstr);
			if( $result===false ){
				$this->mLog->addError('Update Error: SQL=[' . $sqlstr . ']');
				$this->_processReport();
				return false;
			}
		}

		return true;

	}

	/*
	 * V1.31 -> V2.0
	 * xoops_configơ֥conf_titleconf_descvarchar(30)ξϡvarchar(255)ΰĥ
	 */
	function chg_V200_config_colchg(){
		$dbGm = new BBSB_DbGame($this->mDirName);

		// xoops_configơ֥conf_titleconf_descvarchar(30)ξϡvarchar(255)ΰĥ
		// <> http://xc-tokai.net/modules/xhnewbb/viewtopic.php?topic_id=34&post_id=263&viewmode=thread#forumpost263
		$check_sql = "SHOW COLUMNS FROM " . $dbGm->mDb->prefix("config") . " LIKE 'conf_title'" ;
		$fcheck = $dbGm->getList($check_sql);
		if( $fcheck ){
			if( $fcheck[0]['Type'] == 'varchar(30)' ){
				$sqlstr = "ALTER TABLE " . $dbGm->mDb->prefix("config") . " MODIFY `conf_title` varchar(255) NOT NULL default '', MODIFY `conf_desc` varchar(255) NOT NULL default ''";
				$result = $dbGm->execute( $sqlstr );
				if( $result===false ){
					$this->mLog->addError('Update Error: sql=[' . $sqlstr . ']' );
					$this->_processReport();
					return false;
				}
			}
		}
		return true;
	}

	/*
	 * V1.22 -> V1.30
	 * bb_memberUniformNoINTVARCHAR(8)ѹ
	 */
	function chg_V130_UniformNo_int2vc8(){
		$dbMe = new BBSB_DbMember($this->mDirName);
		$sqlstr = "DESCRIBE " . $dbMe->mDb->prefix('bb_member') . " UniformNo";
		$result = $dbMe->execute($sqlstr);
		if( $result!==false ){
			if( strpos($result['Type'], 'smallint(5)') !== 0 ){
				// smallint(5)ξVARCHAR(8)ѹ
				$sqlstr = "ALTER TABLE " . $dbMe->mDb->prefix('bb_member') . " MODIFY UniformNo VARCHAR(8) NULL";
				$result = $dbMe->execute($sqlstr);
				if( $result===false ){
					$this->mLog->addError('Update Error: Alter Table failed.  TABLE=[' . $dbMe->mDb->prefix('bb_smember') . '], COLUMN=[UniformNo]' );
					$this->_processReport();
					return false;
				}
			}
		}
		return true;
	}

}
?>
