<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/*
 * scheduleơ֥륯饹
 */
class BBSB_DbSchedule extends BBSB_AbstractDatabase {
    function __construct($mydirname) {
		parent::__construct($mydirname);
    }

    /**
     * ǯꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
     * @return unknown_type
     */
    function getSelectYearList(){
		$sqlstr =	" SELECT EventYear FROM " . $this->prefix_dir('bb_schedule');
		$sqlstr .=	" GROUP BY EventYear ASC ";
    	return $this->getList( $sqlstr );
    }

    /**
     * /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼)
     * @return unknown_type
     */
    function getSelectSTournamentList(){
	    $sqlstr =	" SELECT T.TournamentID,TournamentName ";
		$sqlstr .=	" FROM " . $this->prefix_dir('bb_schedule') . " S, " . $this->prefix_dir('bb_tournament') . " T ";
		$sqlstr .=	" WHERE S.TournamentID=T.TournamentID ";
		$sqlstr .=	" GROUP BY S.TournamentID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * 饦ɥꥹȼ(饦ɥơ֥¸ߤ뤹٤ƤΥ饦ɥꥹȤǤϤʤżӤΤ륰饦ɤΤ߼)
     * @return unknown_type
     */
    function getSelectSGroundList(){
		$sqlstr =	" SELECT GR.GroundID,GroundName ";
		$sqlstr .=	" FROM " . $this->prefix_dir('bb_schedule') . " S, " . $this->prefix_dir('bb_ground') . " GR ";
		$sqlstr .=	" WHERE S.GroundID=GR.GroundID";
		$sqlstr .=	" GROUP BY S.GroundID ASC ";
		return $this->getList( $sqlstr );
    }

    /**
     * ꥹȼ(ơ֥¸ߤƤꥹȤǤϤʤӤΤΤ߼)
     * @return unknown_type
     */
	function getSelectSOpponentList(){
		$sqlstr =	" SELECT O.TeamID,TeamName ";
		$sqlstr .=	" FROM " . $this->prefix_dir('bb_schedule') . " S, " . $this->prefix_dir('bb_opponent') . " O ";
		$sqlstr .=	" WHERE S.Opponent1=O.TeamID or S.Opponent2=O.TeamID or S.Opponent3=O.TeamID ";
		$sqlstr .=	" GROUP BY O.TeamID ";
		$sqlstr .=	" ORDER BY LastGameDate IS NULL DESC, LastGameDate DESC ";
		$list = $this->getList( $sqlstr );
		// ꥹȤκǸ˹Ѥ(=0)ɲä
		$list[]=array('TeamID'=>0, 'TeamName'=>_BBSB_OP_OWNTEAMNAME1 . "(" ._MD_BBSB_LANG_KOHAKUSEN.")");
		return $list;
	}

    /**
     * 塼ꥹȼ
     * @return unknown_type
     */
	function getScheduleList( $wherestr, $sort="DESC", $limit=false ){
		// SQLʸ
		$sqlstr =	" SELECT SQL_CALC_FOUND_ROWS ScheduleID,EventName,EventYear,EventMonth,EventDay,EventHour,EventMinute,";
		$sqlstr .=	"Submitter,SubmitterEmail,DispEmailFlg,NoticeEmailFlg,EventKind,GroundName,TournamentName,";
		$sqlstr .=	"O1.TeamName AS TeamName1, O2.TeamName AS TeamName2, O3.TeamName AS TeamName3, ";
		$sqlstr .=	" ( SELECT COUNT( SM.EntrantID ) ";
		$sqlstr .=	"     FROM " .  $this->prefix_dir('bb_joinstate') . " J ";
		$sqlstr .=	"     LEFT JOIN " . $this->prefix_dir('bb_schedulemember') . " SM ";
		$sqlstr .=	"       ON J.ScheduleID=SM.ScheduleID AND J.JoinStateID=SM.JoinStateID ";
		$sqlstr .=	"    WHERE J.ScheduleID=S.ScheduleID  AND J.Section='1' ) AS Sanka, ";
		$sqlstr .=	" ( SELECT COUNT( SM.EntrantID ) ";
		$sqlstr .=	"     FROM " .  $this->prefix_dir('bb_joinstate') . " J ";
		$sqlstr .=	"     LEFT JOIN " . $this->prefix_dir('bb_schedulemember') . " SM ";
		$sqlstr .=	"       ON J.ScheduleID=SM.ScheduleID AND J.JoinStateID=SM.JoinStateID ";
		$sqlstr .=	"    WHERE J.ScheduleID=S.ScheduleID  AND J.Section='2' ) AS Husanka, ";
		$sqlstr .=	" ( SELECT COUNT( SM.EntrantID ) ";
		$sqlstr .=	"     FROM " .  $this->prefix_dir('bb_joinstate') . " J ";
		$sqlstr .=	"     LEFT JOIN " . $this->prefix_dir('bb_schedulemember') . " SM ";
		$sqlstr .=	"       ON J.ScheduleID=SM.ScheduleID AND J.JoinStateID=SM.JoinStateID ";
		$sqlstr .=	"    WHERE J.ScheduleID=S.ScheduleID  AND J.Section='3' ) AS Mitei ";
		$sqlstr .=	" FROM " . $this->prefix_dir('bb_schedule') . " S ";
		$sqlstr .=	" LEFT JOIN " . $this->prefix_dir('bb_tournament') . " T  ON S.TournamentID=T.TournamentID ";
		$sqlstr .=	" LEFT JOIN " . $this->prefix_dir('bb_ground')     . " GR ON S.GroundID=GR.GroundID ";
		$sqlstr .=	" LEFT JOIN " . $this->prefix_dir('bb_opponent')   . " O1 ON S.Opponent1=O1.TeamID ";
		$sqlstr .=	" LEFT JOIN " . $this->prefix_dir('bb_opponent')   . " O2 ON S.Opponent2=O2.TeamID ";
		$sqlstr .=	" LEFT JOIN " . $this->prefix_dir('bb_opponent')   . " O3 ON S.Opponent3=O3.TeamID ";
		$sqlstr .=	$wherestr . " ORDER BY S.EventYear " . $sort . " ,S.EventMonth " . $sort . " ,S.EventDay ";
		$sqlstr .=		$sort . " ,S.EventHour " . $sort . " ,S.EventMinute " . $sort;
		if( $limit ){
			$sqlstr .= " LIMIT " . $limit;
		}
		return $this->getList( $sqlstr );
	}
}
?>