<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/***
 * եࡧϿ
 */
class BBSB_EditMemberdetailForm extends XCube_ActionForm
{
	var	$mMyDirName	= null;		// ⥸塼ǥ쥯ȥ̾
    function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
		require_once XOOPS_MODULE_PATH . "/" . $this->mMyDirName . "/class/DbMember.class.php";
    }

	/**
	 *
	 * @var XCube_FormImageFile
	 */
	var $mFormFile = null;

	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['uid']			= new XCube_IntProperty('uid');			// ֥桼ID
		$this->mFormProperties['uniformno']		= new XCube_StringProperty('uniformno');		// ֹ
		$this->mFormProperties['fullname']		= new XCube_StringProperty('fullname');	// ֻ̾
		$this->mFormProperties['nickname']		= new XCube_StringProperty('nickname');	// ֥˥å͡
		$this->mFormProperties['post']			= new XCube_StringProperty('post');		// 򿦡
		$this->mFormProperties['position1']		= new XCube_IntProperty('position1');		// ֥ݥ1
		$this->mFormProperties['position2']		= new XCube_IntProperty('position2');		// ֥ݥ2
		$this->mFormProperties['position3']		= new XCube_IntProperty('position3');		// ֥ݥ3
		$this->mFormProperties['position4']		= new XCube_IntProperty('position4');		// ֥ݥ4
		$this->mFormProperties['position5']		= new XCube_IntProperty('position5');		// ֥ݥ5
		$this->mFormProperties['position6']		= new XCube_IntProperty('position6');		// ֥ݥ6
		$this->mFormProperties['position7']		= new XCube_IntProperty('position7');		// ֥ݥ7
		$this->mFormProperties['position8']		= new XCube_IntProperty('position8');		// ֥ݥ8
		$this->mFormProperties['position9']		= new XCube_IntProperty('position9');		// ֥ݥ9
		$this->mFormProperties['pandb']			= new XCube_StringProperty('pandb');		// ǡ
		$this->mFormProperties['birthyear']		= new XCube_IntProperty('birthyear');		// ǯ
		$this->mFormProperties['birthmonth']	= new XCube_IntProperty('birthmonth');		// ·
		$this->mFormProperties['birthday']		= new XCube_IntProperty('birthday');		// 
		$this->mFormProperties['phoneno']		= new XCube_StringProperty('phoneno');		// á
		$this->mFormProperties['mphoneno']		= new XCube_StringProperty('mphoneno');	// ַá
		$this->mFormProperties['memail']		= new XCube_StringProperty('memail');		// ַӥ᡼
		$this->mFormProperties['pcemail']		= new XCube_StringProperty('pcemail');		// PC᡼
		$this->mFormProperties['zipcode']		= new XCube_StringProperty('zipcode');		// ͹ֹ
		$this->mFormProperties['address']		= new XCube_StringProperty('address');		// ֽ
		$this->mFormProperties['scoreentry']	= new XCube_BoolProperty('scoreentry');	// ֥Ͽݡ
		$this->mFormProperties['profileentry']	= new XCube_BoolProperty('profileentry');	// ֥ץեɽݡ
		$this->mFormProperties['profile']		= new XCube_TextProperty('profile');		// ֥ץե
		$this->mFormProperties['mailreceive']	= new XCube_BoolProperty('mailreceive');	// ֥᡼
		$this->mFormProperties['showorder']		= new XCube_IntProperty('showorder');		// ɽ
		$this->mFormProperties['imgfile']		= new XCube_ImageFileProperty('imgfile');		// ֲ

		// 桼ID
		$this->mFieldProperties['uid']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['uid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['uid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_USERID, "5");
		$this->mFieldProperties['uid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_USERID);
		$this->mFieldProperties['uid']->addVar('maxlength', 5);
		$this->mFieldProperties['uid']->addVar('min', '1');
		$this->mFieldProperties['uid']->addVar('max', '32767');
		// ֹ
		$this->mFieldProperties['uniformno']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['uniformno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['uniformno']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_UNIFORMNO, "5");
		$this->mFieldProperties['uniformno']->addVar('maxlength', 5);
		// ̾
		$this->mFieldProperties['fullname']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['fullname']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['fullname']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_FULLNAME, '128');
		$this->mFieldProperties['fullname']->addVar('maxlength', 128);
		// ˥å͡
		$this->mFieldProperties['nickname']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['nickname']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['nickname']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_NICKNAME, '128');
		$this->mFieldProperties['nickname']->addVar('maxlength', 128);
		// 
		$this->mFieldProperties['post']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['post']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['post']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POST, '128');
		$this->mFieldProperties['post']->addVar('maxlength', 128);
		// ݥ1
		$this->mFieldProperties['position1']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position1']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position1']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position1']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position1']->addVar('maxlength', 1);
		$this->mFieldProperties['position1']->addVar('min', '0');
		$this->mFieldProperties['position1']->addVar('max', '9');
		// ݥ2
		$this->mFieldProperties['position2']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position2']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position2']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position2']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position2']->addVar('maxlength', 1);
		$this->mFieldProperties['position2']->addVar('min', '0');
		$this->mFieldProperties['position2']->addVar('max', '9');
		// ݥ3
		$this->mFieldProperties['position3']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position3']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position3']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position3']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position3']->addVar('maxlength', 1);
		$this->mFieldProperties['position3']->addVar('min', '0');
		$this->mFieldProperties['position3']->addVar('max', '9');
		// ݥ4
		$this->mFieldProperties['position4']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position4']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position4']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position4']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position4']->addVar('maxlength', 1);
		$this->mFieldProperties['position4']->addVar('min', '0');
		$this->mFieldProperties['position4']->addVar('max', '9');
		// ݥ5
		$this->mFieldProperties['position5']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position5']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position5']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position5']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position5']->addVar('maxlength', 1);
		$this->mFieldProperties['position5']->addVar('min', '0');
		$this->mFieldProperties['position5']->addVar('max', '9');
		// ݥ6
		$this->mFieldProperties['position6']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position6']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position6']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position6']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position6']->addVar('maxlength', 1);
		$this->mFieldProperties['position6']->addVar('min', '0');
		$this->mFieldProperties['position6']->addVar('max', '9');
		// ݥ7
		$this->mFieldProperties['position7']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position7']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position7']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position7']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position7']->addVar('maxlength', 1);
		$this->mFieldProperties['position7']->addVar('min', '0');
		$this->mFieldProperties['position7']->addVar('max', '9');
		// ݥ8
		$this->mFieldProperties['position8']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position8']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position8']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position8']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position8']->addVar('maxlength', 1);
		$this->mFieldProperties['position8']->addVar('min', '0');
		$this->mFieldProperties['position8']->addVar('max', '9');
		// ݥ9
		$this->mFieldProperties['position9']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['position9']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position9']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position9']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position9']->addVar('maxlength', 1);
		$this->mFieldProperties['position9']->addVar('min', '0');
		$this->mFieldProperties['position9']->addVar('max', '9');
		// 
		$this->mFieldProperties['pandb']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['pandb']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['pandb']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PANDB, '128');
		$this->mFieldProperties['pandb']->addVar('maxlength', 128);
		// ǯ
		$this->mFieldProperties['birthyear']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['birthyear']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['birthyear']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_EVENTYEAR, "4");
		$this->mFieldProperties['birthyear']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_EVENTYEAR);
		$this->mFieldProperties['birthyear']->addVar('maxlength', 4);
		$this->mFieldProperties['birthyear']->addVar('min', '0');
		$this->mFieldProperties['birthyear']->addVar('max', '2100');
		// ·
		$this->mFieldProperties['birthmonth']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['birthmonth']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['birthmonth']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_EVENTMONTH, "2");
		$this->mFieldProperties['birthmonth']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_EVENTMONTH);
		$this->mFieldProperties['birthmonth']->addVar('maxlength', 2);
		$this->mFieldProperties['birthmonth']->addVar('min', '0');
		$this->mFieldProperties['birthmonth']->addVar('max', '12');
		// 
		$this->mFieldProperties['birthday']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['birthday']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['birthday']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_EVENTDAY, "2");
		$this->mFieldProperties['birthday']->addMessage('intRange',				_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_EVENTDAY);
		$this->mFieldProperties['birthday']->addVar('maxlength', 2);
		$this->mFieldProperties['birthday']->addVar('min', '0');
		$this->mFieldProperties['birthday']->addVar('max', '31');
		// 
		$this->mFieldProperties['phoneno']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['phoneno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['phoneno']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PHONENUMBER, '32');
		$this->mFieldProperties['phoneno']->addVar('maxlength', 32);
		// 
		$this->mFieldProperties['mphoneno']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['mphoneno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['mphoneno']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_MOBILEPHONE, '32');
		$this->mFieldProperties['mphoneno']->addVar('maxlength', 32);
		// ӥ᡼
		$this->mFieldProperties['memail']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['memail']->setDependsByArray(array('maxlength', 'email'));
		$this->mFieldProperties['memail']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_MOBILEEMAIL, '256');
		$this->mFieldProperties['memail']->addVar('maxlength', 256);
		$this->mFieldProperties['memail']->addMessage('email', _MD_BBSB_ERROR_EMAIL );
		// PC᡼
		$this->mFieldProperties['pcemail']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['pcemail']->setDependsByArray(array('maxlength', 'email'));
		$this->mFieldProperties['pcemail']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PCEMAIL, '256');
		$this->mFieldProperties['pcemail']->addVar('maxlength', 256);
		$this->mFieldProperties['pcemail']->addMessage('email', _MD_BBSB_ERROR_EMAIL );
		// ͹ֹ
		$this->mFieldProperties['zipcode']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['zipcode']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['zipcode']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_ZIPCODE, '16');
		$this->mFieldProperties['zipcode']->addVar('maxlength', 16);
		// 
		$this->mFieldProperties['address']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['address']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['address']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_ADRESS, '1024');
		$this->mFieldProperties['address']->addVar('maxlength', 1024);
		// ץե
		$this->mFieldProperties['profile']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['profile']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['profile']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PROFILE, '10000');
		$this->mFieldProperties['profile']->addVar('maxlength', 10000);
		// ɽ
		$this->mFieldProperties['showorder']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['showorder']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['showorder']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_SHOWORDER, "5");
		$this->mFieldProperties['showorder']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_SHOWORDER);
		$this->mFieldProperties['showorder']->addVar('maxlength', 5);
		$this->mFieldProperties['showorder']->addVar('min', '0');
		$this->mFieldProperties['showorder']->addVar('max', '32767');
		// 
		$this->mFieldProperties['img_file']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['img_file']->setDependsByArray(array('extension', 'maxfilesize'));
		$this->mFieldProperties['img_file']->addMessage('extension', _MD_BBSB_ERROR_FILE_EXTENSION);
		$this->mFieldProperties['img_file']->addVar('extension', "jpg,gif,png");
		$this->mFieldProperties['img_file']->addMessage('maxfilesize', _MD_BBSB_ERROR_MAXFILESIZE);
		$this->mFieldProperties['img_file']->addVar('maxfilesize', 1000000);	// 1MB

	}

	/**
	 * ̾˥å͡Τ줫ϤƤʤϥ顼
	 * ̾˥å͡ब Ʊ̾ϿƤХ顼
	 * @return unknown_type
	 */
	function validateNickName(){
		if( !$this->get('fullname') && !$this->get('nickname') ){
				$this->addErrorMessage(_MD_BBSB_ERROR_BLANKNAME);
		}
		if( $this->get('uid') ){
			$exarray = array( 'UserID' => $this->get('uid') );	// UserID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;									// UserID̵(=)
		}

		// ̾ʣå
		if( $this->get('fullname') ){
			$dbOp = new BBSB_DbMember($this->mMyDirName);
			$dbOp->setData( 'FullName',	$this->get('fullname') );
			$count = $dbOp->CountNum( 'bb_member', $exarray );
			if( $count != 0 ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_FULLNAME));
			}
		}
		// ˥å͡ʣå
		if( $this->get('nickname') ){
			$dbOp = new BBSB_DbMember($this->mMyDirName);
			$dbOp->setData( 'NickName',	$this->get('nickname') );
			$count = $dbOp->CountNum( 'bb_member', $exarray );
			if( $count != 0 ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_NICKNAME));
			}
		}
	}

	/**
	 * ե¸롣
	 * @param $path
	 * @param $putfilename
	 * @return unknown_type
	 */
	function putImgFile( $path, $putfilename ){
		$this->mFormFile = $this->get('imgfile');
		if ($this->mFormFile != null) {
			$this->mFormFile->setBodyName( $putfilename );
			if ( !$this->mFormFile->saveAs( $path )) {
				$msgpath = strstr( $path, 'modules');
				if( !$msgpath ){
					$msgpath = $path;
				}
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_PUTFILE, $msgpath));
				return BBSB_FRAME_VIEW_INPUT;
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
