<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/**
 * եࡧ̰ܺ
 */
class BBSB_ViewGameForm extends XCube_ActionForm
{
    function __construct() {
		parent::XCube_ActionForm();
    }

	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['cond_ownteamid']	= new XCube_IntProperty('cond_ownteamid');		// ID
		$this->mFormProperties['cond_nendo']		= new XCube_IntProperty('cond_nendo');			// ǯ
		$this->mFormProperties['cond_month']		= new XCube_IntProperty('cond_month');			// 
		$this->mFormProperties['cond_leagueid']		= new XCube_IntProperty('cond_leagueid');		// ꡼ID
		$this->mFormProperties['cond_tournamentid']	= new XCube_IntProperty('cond_tournamentid');	// /ȡʥID
		$this->mFormProperties['cond_gameorderid']	= new XCube_IntProperty('cond_gameorderid');	// 
		$this->mFormProperties['cond_groundid']		= new XCube_IntProperty('cond_groundid');		// 饦ID
		$this->mFormProperties['cond_opponentid']	= new XCube_IntProperty('cond_firstteamid');	// ID
		$this->mFormProperties['cond_start']		= new XCube_IntProperty('cond_start');			// ϥڡ
		$this->mFormProperties['cond_perpage']		= new XCube_IntProperty('cond_perpage');		// 1ڡη

		// ID
		$this->mFieldProperties['cond_ownteamid']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_ownteamid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_ownteamid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEID, "3");
		$this->mFieldProperties['cond_ownteamid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEID);
		$this->mFieldProperties['cond_ownteamid']->addVar('maxlength', 3);
		$this->mFieldProperties['cond_ownteamid']->addVar('min', '-10');
		$this->mFieldProperties['cond_ownteamid']->addVar('max', '0');
		// ǯ
		$this->mFieldProperties['cond_nendo']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_nendo']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_nendo']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_EVENTNENDO, "4");
		$this->mFieldProperties['cond_nendo']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_EVENTNENDO);
		$this->mFieldProperties['cond_nendo']->addVar('maxlength', 4);
		$this->mFieldProperties['cond_nendo']->addVar('min', '0');
		$this->mFieldProperties['cond_nendo']->addVar('max', '2050');
		// 
		$this->mFieldProperties['cond_month']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_month']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_month']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_EVENTMONTH, "2");
		$this->mFieldProperties['cond_month']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_EVENTMONTH);
		$this->mFieldProperties['cond_month']->addVar('maxlength', 2);
		$this->mFieldProperties['cond_month']->addVar('min', '0');
		$this->mFieldProperties['cond_month']->addVar('max', '12');
		// ꡼ID
		$this->mFieldProperties['cond_leagueid']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_leagueid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_leagueid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_LEAGUE, "5");
		$this->mFieldProperties['cond_leagueid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_LEAGUE);
		$this->mFieldProperties['cond_leagueid']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_leagueid']->addVar('min', '0');
		$this->mFieldProperties['cond_leagueid']->addVar('max', '32767');
		// /ȡʥID
		$this->mFieldProperties['cond_tournamentid']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_tournamentid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_tournamentid']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_TOURNAMENT, "5");
		$this->mFieldProperties['cond_tournamentid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_TOURNAMENT);
		$this->mFieldProperties['cond_tournamentid']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_tournamentid']->addVar('min', '0');
		$this->mFieldProperties['cond_tournamentid']->addVar('max', '32767');
		// 
		$this->mFieldProperties['cond_gameorderid']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_gameorderid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_gameorderid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEORDER, "5");
		$this->mFieldProperties['cond_gameorderid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEORDER);
		$this->mFieldProperties['cond_gameorderid']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_gameorderid']->addVar('min', '0');
		$this->mFieldProperties['cond_gameorderid']->addVar('max', '32767');
		// 饦ID
		$this->mFieldProperties['cond_groundid']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_groundid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_groundid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GROUNDID, "5");
		$this->mFieldProperties['cond_groundid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GROUNDID);
		$this->mFieldProperties['cond_groundid']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_groundid']->addVar('min', '0');
		$this->mFieldProperties['cond_groundid']->addVar('max', '32767');
		// ID
		$this->mFieldProperties['cond_opponentid']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_opponentid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_opponentid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_TEAMNAME, "5");
		$this->mFieldProperties['cond_opponentid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_TEAMNAME);
		$this->mFieldProperties['cond_opponentid']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_opponentid']->addVar('min', '-10');
		$this->mFieldProperties['cond_opponentid']->addVar('max', '32767');
		// ϥڡ
		$this->mFieldProperties['cond_start']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_start']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_start']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_STARTPAGE, "5");
		$this->mFieldProperties['cond_start']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,		_MD_BBSB_LANG_STARTPAGE);
		$this->mFieldProperties['cond_start']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_start']->addVar('min', '0');
		$this->mFieldProperties['cond_start']->addVar('max', '32767');
		// 1ڡη
		$this->mFieldProperties['cond_perpage']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['cond_perpage']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['cond_perpage']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_PERPAGE, "5");
		$this->mFieldProperties['cond_perpage']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,		_MD_BBSB_LANG_PERPAGE);
		$this->mFieldProperties['cond_perpage']->addVar('maxlength', 5);
		$this->mFieldProperties['cond_perpage']->addVar('min', '0');
		$this->mFieldProperties['cond_perpage']->addVar('max', '32767');

	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}

?>
