<?php
// Module Info
$mydirname = basename(dirname(dirname(dirname(__FILE__))));
$constpref = '_MI_' . strtoupper( $mydirname );

if( !defined( $constpref.'_LOADED' ) ) {
define( $constpref.'_LOADED' , 1 ) ;

// A brief description of this module
define($constpref."_DESC",							"野球スコアブック管理モジュール");

// Admin Menu
define($constpref."_ADMENU_UPDATEMODULE",			"最新モジュールの確認");
define($constpref."_ADMENU_SWITCHOVER",				"データ移行ツール");

// Sub menu titles
define($constpref."_MENU_SCHEDULE",					"活動予定");
define($constpref."_MENU_VIEWGAMELIST",				"対戦成績");
define($constpref."_MENU_VIEWMEMBERLIST",			"選手紹介");
define($constpref."_MENU_VIEWPERSONALSCORE",		"個人成績");
define($constpref."_MENU_OPPONENT",					"対戦相手管理");
define($constpref."_MENU_GROUND",					"グラウンド管理");
define($constpref."_MENU_LEAGUE",					"主催・リーグ管理");
define($constpref."_MENU_TOURNAMENT",				"大会・回戦管理");

define($constpref."_MENU_VIEWSCHEDULEDETAIL",		"活動予定詳細");
define($constpref."_MENU_EDITSCHEDULEDETAIL",		"活動予定登録");
define($constpref."_MENU_EDITSCHEDULEMEMBERDETAIL",	"出欠登録");
define($constpref."_MENU_VIEWGAMEDETAIL",			"対戦結果詳細");
define($constpref."_MENU_EDITGAMEDETAIL",			"対戦結果登録");
define($constpref."_MENU_EDITMEMBERDETAIL",			"選手情報登録");
define($constpref."_MENU_VIEWOPPONENTDETAIL",		"対戦相手情報詳細");
define($constpref."_MENU_EDITOPPONENTDETAIL",		"対戦相手情報登録");
define($constpref."_MENU_VIEWGROUNDDETAIL",			"グラウンド情報詳細");
define($constpref."_MENU_EDITGROUNDDETAIL",			"グラウンド情報登録");
define($constpref."_MENU_EDITLEAGUEDETAIL",			"主催・リーグ情報登録");
define($constpref."_MENU_EDITTOURNAMENTDETAIL",		"大会・トーナメント情報登録");
define($constpref."_MENU_EDITGAMEORDERDETAIL",		"回戦情報登録");

define($constpref."_MENU_EDITGAMEDETAILMENT",		"打順・参加選手登録");
define($constpref."_MENU_EDITGAMEDETAILMINN",		"打撃成績登録");
define($constpref."_MENU_EDITGAMEDETAILMPIT",		"投手成績登録");

// Config
define($constpref."_CFG_INNINGS_T",					"1試合あたりのイニング数");
define($constpref."_CFG_INNINGS_D",					"草野球なら7、一般の野球なら9にしてください。主に防御率計算用。");

define($constpref."_CFG_ENTRYINNINGS_T",			"登録/更新可能な最大イニング");
define($constpref."_CFG_ENTRYINNINGS_D",			"あまり大きな値にするとレイアウトが崩れるので12を推奨します。この値より大きいイニングは登録できません。");

define($constpref."_CFG_DISPINNINGS_T",				"表示用イニング数");
define($constpref."_CFG_DISPINNINGS_D",				"対戦成績一覧画面などで、表示用レイアウトをカスタマイズしたいときに調節してください。");

define($constpref."_CFG_STARTYEAR_T",				"チーム設立年(西暦)");
define($constpref."_CFG_STARTYEAR_D",				"対戦結果が入力可能な範囲は、この年以降になります。");

define($constpref."_CFG_OWNTEAMNAME_T1",			"自チーム名称1");
define($constpref."_CFG_OWNTEAMNAME_D1",			"必須:チームの名称。");
define($constpref."_CFG_OWNTEAMNAME_V1",			"自チーム");
define($constpref."_CFG_OWNTEAMNAME_T2",			"自チーム名称2");
define($constpref."_CFG_OWNTEAMNAME_D2",			"任意:セカンドチームまたは2軍の名称。");
define($constpref."_CFG_OWNTEAMNAME_T3",			"自チーム名称3");
define($constpref."_CFG_OWNTEAMNAME_D3",			"任意:サードチームまたは3軍の名称。");

define($constpref."_CFG_REGURATION_T",				"規定打席数");
define($constpref."_CFG_REGURATION_D",				"1試合あたりの規定打席を入力してください。");

define($constpref."_CFG_PREGURATION_T",				"規定投球回数");
define($constpref."_CFG_PREGURATION_D",				"1試合あたりの規定投球回数を入力してください。");

define($constpref."_CFG_NAMEDISP_T",				"氏名表示に本名を使用する");
define($constpref."_CFG_NAMEDISP_D",				"「いいえ」にした場合はニックネームを使用します。ただしニックネームが登録されている時のみ。");

define($constpref."_CFG_DISPSCORE_T",				"個人成績を公開する");
define($constpref."_CFG_DISPSCORE_D",				"「いいえ」にした場合は個人成績一覧画面と、試合詳細の打撃成績/投手成績ををゲスト公開しません。ログインが必要となります。");

define($constpref."_CFG_DISPSCHE_T",				"「活動予定」機能を使用する");
define($constpref."_CFG_DISPSCHE_D",				"「いいえ」にした場合は活動予定機能をメニューから外します。");

define($constpref."_CFG_SCHECAPTCHA_T",				"活動予定の出欠登録に画像認証を使用する");
define($constpref."_CFG_SCHECAPTCHA_D",				"出欠登録がSPAM等に荒らされる場合は対策のため認証をオンにしてください。(要GDライブラリ)");

// Blocks
define($constpref."_BLOCK_RECENT_SCHE_T",			"チームの活動予定");
define($constpref."_BLOCK_RECENT_SCHE_D",			"試合、練習などの活動予定を表示します。");

define($constpref."_BLOCK_RECENT_GAME_T",			"最近の試合");
define($constpref."_BLOCK_RECENT_GAME_D",			"最近に行われた試合の概要をを表示します。");
}
?>