<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * Ͽ(ϿMobile)
 * MobileǤΤ߻ѡϿ
 */
class BBSB_EditGamedetailMentAction extends BBSB_AbstractEditAction
{
	var $mBatScoreList			= array();		// Ƿӥǡ
	var	$mActionFormCond		= null;			// ե(GETѥ᡼)

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/EditGamedetailMentForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/ViewGameForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGame.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbMember.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGameEntrant.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGameBatter.class.php";
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_EditGamedetailMentForm($this->mMyDirName);
		$this->mActionForm->prepare();
		$this->mActionFormCond	= new BBSB_ViewGameForm();
		$this->mActionFormCond->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		$this->mActionFormCond->load($this->mObject);	// եΥ
		$this->mActionFormCond->fetch();				// ꥯȥեफͤμ
		$this->mActionFormCond->validate();				// ͭȽ

		if( xoops_getrequest('gid') ){
			// gidȤ(ϻ)
			$gid		= xoops_getrequest('gid');

			// ǡեǤ˥å
			$this->mActionForm->mFormProperties['gid']->mValue			= $gid;			// GameID

			// GameIDɳդüԥǡ
			$entList = array();
			$dbEt = new BBSB_DbGameEntrant($this->mMyDirName);
			$sqlstr =	" SELECT M.UniformNo,E.* ";
			$sqlstr .=	" FROM " . $dbEt->prefix_dir('bb_gameentrant') . " E, ";
			$sqlstr .=			$dbEt->prefix_dir('bb_member') . " M ";
			$sqlstr .=  " WHERE E.GameID='" . $gid . "' ";
			$sqlstr	.=	"   AND E.UserID=M.UserID ";
			$sqlstr .=	" ORDER BY E.PlayOrder, E.ChangeCnt ";
			$entList = $dbEt->getList( $sqlstr );

			// üԥǡեϤ˥å
			foreach( $entList as $key => $edat ){
				$this->mBatScoreList[$key]['playorder']		= $edat['PlayOrder'];
				$this->mBatScoreList[$key]['changecnt']		= $edat['ChangeCnt'];
				$this->mBatScoreList[$key]['uniformno']		= $edat['UniformNo'];
				$this->mBatScoreList[$key]['position1']		= $edat['Position1'];
				$this->mBatScoreList[$key]['position2']		= $edat['Position2'];
				$this->mBatScoreList[$key]['stolenbasesuc']	= $edat['StolenBaseSuc'];
				$this->mBatScoreList[$key]['stolenbasefail']= $edat['StolenBaseFail'];
				$this->mBatScoreList[$key]['runscnt']		= $edat['RunsCnt'];
				$this->mBatScoreList[$key]['errorscnt']		= $edat['ErrorsCnt'];
				$this->mBatScoreList[$key]['winningrun']	= $edat['WinningRun'];
			}
			if( !$entList ){
				// ǷǡޤƤʤ硧
				// ǷǡΥǥեȤ򥻥åȤ롣
				for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM ; $rcnt++ ){
					// ǽ9ܤޤǤιԤǽͤ򥻥åȤƤ
					if( $rcnt < 9 ){
						$this->mBatScoreList[$rcnt]['playorder']	= $rcnt+1;
					} else {
						$this->mBatScoreList[$rcnt]['playorder']	= "";
					}
				}
			}
		} else {
			// gid ̵ȤȤߤʤ
			$controller->executeForward("./index.php" );
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		$this->mActionForm->load($this->mObject);		// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();					// ꥯȥեफͤμ
		$this->mActionFormCond->load($this->mObject);	// եΥ
		$this->mActionFormCond->fetch();				// ꥯȥեफͤμ

		// 󥻥 (POSTϤѥ᡼뤿ᡢloadfetchȤ˥󥻥Ƚꤹ)
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->validate();					// ͭͤ
		$this->mActionFormCond->validate();				// ͭȽ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// Ƿǡ򥽡Ȥ
		$lplayorder			= array();	// ǽ()
		$lchangecnt			= array();	// ȯ/()
		$lB					= array();	// ХåǷǡ
		$uid				= array();
		$dbM				= new BBSB_DbMember($this->mMyDirName);
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM ; $rcnt++ ){	// Хå롼
			if( $this->mActionForm->mFormProperties['playorder']->mProperties[$rcnt]->mValue == "" ){continue;}
			$lplayorder[$rcnt]			= $this->mActionForm->mFormProperties['playorder']->mProperties[$rcnt]->mValue;
			$lchangecnt[$rcnt]			= $this->mActionForm->mFormProperties['changecnt']->mProperties[$rcnt]->mValue;

			$lB[$rcnt]['PlayOrder']		= $this->mActionForm->mFormProperties['playorder']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['ChangeCnt']		= $this->mActionForm->mFormProperties['changecnt']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['UniformNo']		= $this->mActionForm->mFormProperties['uniformno']->mProperties[$rcnt]->mValue;
			// UserIDֹ椫
			$dbM->unsetData();
			$dbM->setData( 'UniformNo',	$lB[$rcnt]['UniformNo'] );
			$dbM->setOrderBy( 'UserID', 'ASC' );
			$uid = $dbM->getListbyCond('bb_member','UserID', 1);
			$lB[$rcnt]['UserID']		= $uid[0]['UserID'];
			$lB[$rcnt]['Position1']		= $this->mActionForm->mFormProperties['position1']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['Position2']		= $this->mActionForm->mFormProperties['position2']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['StolenBaseSuc']	= $this->mActionForm->mFormProperties['stolenbasesuc']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['StolenBaseFail']= $this->mActionForm->mFormProperties['stolenbasefail']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['RunsCnt']		= $this->mActionForm->mFormProperties['runscnt']->mProperties[$rcnt]->mValue;
			$lB[$rcnt]['ErrorsCnt']		= $this->mActionForm->mFormProperties['errorscnt']->mProperties[$rcnt]->mValue;
			if( isset($this->mActionForm->mFormProperties['winningrun']->mProperties[$rcnt]) ){
				$lB[$rcnt]['WinningRun']	= $this->mActionForm->mFormProperties['winningrun']->mProperties[$rcnt]->mValue;
			} else {
				$lB[$rcnt]['WinningRun']	= null;
			}
			$lB[$rcnt]['RBI']			= $this->mActionForm->mFormProperties['rbi']->mProperties[$rcnt]->mValue;
		}
		array_multisort( $lplayorder, $lchangecnt, $lB );	// ǽ硢˥

		// üԥơ֥Ͽ(bb_gameentrant)
		$gid = $this->mActionForm->mFormProperties['gid']->mValue;
		$ret = $this->insEntrantData( $gid, $lB );
		if( $ret != BBSB_FRAME_VIEW_SUCCESS ){
			return $ret;
		}

		// 줿üԤ硢Ƿǡơ֥(bb_gamebatter)롣
		$dbGb = new BBSB_DbGameBatter($this->mMyDirName);
		$sqlstr =	" DELETE FROM " . $dbGb->prefix_dir('bb_gamebatter');
		$sqlstr .=	" WHERE GameID='" . $gid . "' ";
		$uidstr = "";
		foreach( $lB as $key => $dat ){
			if( $uidstr ){
				$uidstr .= " AND ";
			}
			$uidstr .= " UserID<>'" . $dat['UserID'] . "' ";
		}
		if( $uidstr ){
			$uidstr = " AND " . $uidstr;
		}
		$sqlstr .= $uidstr;
		$dbGb->getList($sqlstr);

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		// Mobileѥƥץ졼(PCѤ̵)
		$render->setTemplateName("bbsb_editgamedetailMent.html");	// Mobile
		$render->setAttribute("actionForm",		$this->mActionForm);
		$render->setAttribute("actionFormCond",	$this->mActionFormCond);
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_EDITGAMEDETAILMENT') );	// ̾

		if( xoops_getenv("REQUEST_METHOD") == "POST" ){
			// POSTΥեɽ(=ϼԻν)

			// Ƿǡեफ齦
			for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM ; $rcnt++ ){
				// ǽ硢ȯ̾ݡ𼺡
				$this->mBatScoreList[$rcnt]['playorder']		= $this->mActionForm->mFormProperties['playorder']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['changecnt']		= $this->mActionForm->mFormProperties['changecnt']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['UserID']			= $this->mActionForm->mFormProperties['member']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['uniformno']		= $this->mActionForm->mFormProperties['uniformno']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['position1']		= $this->mActionForm->mFormProperties['position1']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['position2']		= $this->mActionForm->mFormProperties['position2']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['stolenbasesuc']	= $this->mActionForm->mFormProperties['stolenbasesuc']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['stolenbasefail']	= $this->mActionForm->mFormProperties['stolenbasefail']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['runscnt']			= $this->mActionForm->mFormProperties['runscnt']->mProperties[$rcnt]->mValue;
				$this->mBatScoreList[$rcnt]['errorscnt']		= $this->mActionForm->mFormProperties['errorscnt']->mProperties[$rcnt]->mValue;
				if( isset($this->mActionForm->mFormProperties['winningrun']->mProperties[$rcnt]) ){
					$this->mBatScoreList[$rcnt]['winningrun']	= $this->mActionForm->mFormProperties['winningrun']->mProperties[$rcnt]->mValue;
				} else {
					$this->mBatScoreList[$rcnt]['winningrun']	= null;
				}
			}
		}

		// IDbb_gameơ֥뤫
		$otList = array();
		$dbGm		= new BBSB_DbGame($this->mMyDirName);
		$sqlstr		=	" SELECT OwnTeamID ";
		$sqlstr		.=	" FROM " . $dbGm->prefix_dir('bb_game') ;
		$sqlstr		.=  " WHERE GameID='" . xoops_getrequest('gid') . "' ";
		$otList		= $dbGm->getList( $sqlstr );
		$OwnTeamID	= $otList[0]['OwnTeamID'];

		// Υᥤ̾
		$ownteams		= array();
		$ownteams		= $this->getOwnTeamName();
		$ownteamname	= "";
		foreach( $ownteams as $key => &$team ){
			if( $team['TeamID'] == $OwnTeamID ){
				$ownteamname = $team['TeamName'];
				break;
			}
		}
		$render->setAttribute("ownteamname",	$ownteamname);

		// ǷӤեǡ˥å
		$render->setAttribute("batscores", 		$this->mBatScoreList);

		// ǽȯ/奻쥯ȥܥå
		$startingList = array(	_MD_BBSB_LANG_CHANGECNT,			// ȯ
								_MD_BBSB_LANG_CHANGECNTCHG . "1",	// 1
								_MD_BBSB_LANG_CHANGECNTCHG . "2",	// 2
								_MD_BBSB_LANG_CHANGECNTCHG . "3",
								_MD_BBSB_LANG_CHANGECNTCHG . "4",
								_MD_BBSB_LANG_CHANGECNTCHG . "5",
								_MD_BBSB_LANG_CHANGECNTCHG . "6",
								_MD_BBSB_LANG_CHANGECNTCHG . "7",
								_MD_BBSB_LANG_CHANGECNTCHG . "8");
		$render->setAttribute("startinglists", $startingList );

	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$gid	= xoops_getrequest('gid');
		$getstr = $this->makeCondStrM();
		$controller->executeForward("./index.php?action=EditGamedetail&gid=" . $gid . $getstr );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν Ͽ̤
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$gid	= xoops_getrequest('gid');
		$getstr = $this->makeCondStrM();
		$controller->executeForward("./index.php?action=EditGamedetail&gid=" . $gid . $getstr );
	}

	/**
	 * Ʋ̤ϤGETѥ᡼
	 */
	function makeCondStrM()
	{
		$getstr	=  "";
		if( $this->mActionFormCond->get('cond_ownteamid')	!== null){
			$getstr .= "&cond_ownteamid="    . $this->mActionFormCond->get('cond_ownteamid');
		}
		if( $this->mActionFormCond->get('cond_nendo')		!== null ){
			$getstr .= "&cond_nendo="        . $this->mActionFormCond->get('cond_nendo');
		}
		if( $this->mActionFormCond->get('cond_month') ){
			$getstr .= "&cond_month="        . $this->mActionFormCond->get('cond_month');
		}
		if( $this->mActionFormCond->get('cond_start') ){
			$getstr .= "&cond_start="        . $this->mActionFormCond->get('cond_start');
		}
		if( $this->mActionFormCond->get('cond_perpage') ){
			$getstr .= "&cond_perpage="      . $this->mActionFormCond->get('cond_perpage');
		}
		return $getstr;
	}


}
?>
