<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/***
 * Ӱ
 */
class BBSB_ViewGamelistAction extends BBSB_AbstractEditAction
{
	var $mNendoList			= array();		// ǯ٥쥯ȥܥåǡ
	var $mLeagueList		= array();		// ꡼/ť쥯ȥܥåǡ
	var $mTournamentList	= array();		// /ȡʥȥ쥯ȥܥåǡ
	var $mGameOrderList		= array();		// 糧쥯ȥܥåǡ
	var $mGroundList		= array();		// 饦ɥ쥯ȥܥåǡ
	var $mOpponentList		= array();		// ꥻ쥯ȥܥåǡ
	var $mGameList			= array();		// ǡ
	var $mInningList		= array();		// ˥󥰥ǡ
	var $mDelMsg			= null;			// 쥳ɺå
	var $mPageNavi			= array();		// PageNavi
	var $mOwnTeamList		= array();		// ̾ꥹ
	var $mCndStr			= null;			// string(GET)
	var $mResultSummary		= array( 'Lose' => 0, 'Win'=>0, 'Even'=>0, 'Etc'=>0 );		// //ʬ/¾ ι׿


	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/forms/ViewGameForm.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbGame.class.php";
	}

    /**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_ViewGameForm($this->mMyDirName);
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	function getDefaultView(&$controller, &$xoopsUser)
	{
		$this->mActionForm->load($this->mObject);	// եΥ
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭȽ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INDEX;
		}

		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbGame = new BBSB_DbGame($this->mMyDirName);

		$this->mNendoList		= $dbGame->getSelectNendoList();		// ǯ٥ꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
		$this->mLeagueList		= $dbGame->getSelectLeagueList();		// ꡼/ťꥹȼ(쥳ɤ¸ߤ꡼Τ߼ǯ٥ꥹȤȤ)
		$this->mLeagueList		= $this->truncatestr( $this->mLeagueList,		'LeagueName', 15 );
		$this->mTournamentList	= $dbGame->getSelectTournamentList();	// /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $this->truncatestr( $this->mTournamentList,	'TournamentName', 19 );
		$this->mGameOrderList	= $dbGame->getSelectGameOrderList();	// ꥹȼ(쥳ɤ¸ߤΤ߼)
		$this->mGameOrderList	= $this->truncatestr( $this->mGameOrderList,	'GameOrderName', 7 );
		$this->mGroundList		= $dbGame->getSelectGroundList();		// 饦ɥꥹȼ(쥳ɤ¸ߤ륰饦ɤΤ߼)
		$this->mGroundList		= $this->truncatestr( $this->mGroundList,		'GroundName', 19 );
		$this->mOpponentList	= $dbGame->getSelectOpponentList( 0 );	// ꥹȼ(쥳ɤ¸ߤΤ߼)
		$this->mOpponentList	= $this->truncatestr( $this->mOpponentList,		'TeamName', 19 );
		$this->mOwnTeamList		= $this->getOwnTeamName();				// ̾μ
		// WHERE
		if( !isset($_GET['cond_nendo']) && $this->mNendoList){
			$maxidx = count($this->mNendoList)-1;
			if( isset($this->mNendoList[$maxidx]['Nendo']) ){
				if( $this->mNendoList[$maxidx]['Nendo'] ){
					$_GET['cond_nendo']	= $this->mNendoList[$maxidx]['Nendo'];	// ǯ٤ꤵƤʤкǿǯ٤ǥ쥳ɼ롣
				}
			}
		}
		// IDåȤƤʤСᥤID(-1)򥻥åȤ롣
		if( !isset($_GET['cond_ownteamid']) ){
			$_GET['cond_ownteamid']	= -1;
		}
		$wherestr	= $this->createWhereStrForSearch();
		$sortstr	= " ORDER BY G.EventDate DESC,GameSeq DESC";

		// ڡּ
		if( !xoops_getrequest('cond_start') && !xoops_getrequest('cond_perpage') ){
			// PageNaviѤλ꤬ʤ0ܤ100Լ(PCξ)
			$startrow	= 0;
			$perpage	= $this->mMobile? _BBSB_PAGENAVI_PERPAGE_M : _BBSB_PAGENAVI_PERPAGE;
		} else {
			$startrow	= intval(xoops_getrequest('cond_start'));
			$perpage	= intval(xoops_getrequest('cond_perpage'));
		}
		$lstr = $startrow . "," . $perpage;

		// ꥹȼ
		$this->mGameList = $dbGame->getGameShowInfo( $wherestr, $lstr, $sortstr, true );
		// ׷
		$cnum = $dbGame->getList( "SELECT FOUND_ROWS() AS CNT" );

		// pagenavi
		$cndstr = "";
		if( xoops_getrequest('cond_ownteamid')!==null){ $cndstr .= "&cond_ownteamid="		. xoops_getrequest('cond_ownteamid'); }
		if( xoops_getrequest('cond_nendo')!==null	){ $cndstr .= "&cond_nendo="			. xoops_getrequest('cond_nendo'); }
		if( xoops_getrequest('cond_month')			){ $cndstr .= "&cond_month="			. xoops_getrequest('cond_month'); }
		if( xoops_getrequest('cond_leagueid')		){ $cndstr .= "&cond_leagueid="			. xoops_getrequest('cond_leagueid'); }
		if( xoops_getrequest('cond_tournamentid')	){ $cndstr .= "&cond_tournamentid="		. xoops_getrequest('cond_tournamentid'); }
		if( xoops_getrequest('cond_gameorderid')	){ $cndstr .= "&cond_gameorderid="		. xoops_getrequest('cond_gameorderid'); }
		if( xoops_getrequest('cond_groundid')		){ $cndstr .= "&cond_groundid="			. xoops_getrequest('cond_groundid'); }
		if( xoops_getrequest('cond_opponentid')		){ $cndstr .= "&cond_opponentid="		. xoops_getrequest('cond_opponentid'); }
		$ustr = _BBSB_MODULE_URL . "index.php?action=ViewGamelist" . $cndstr;
		$ustr .= "&cond_perpage=" . $perpage;
		$this->mPageNavi = $this->setPageNavi( $startrow, $perpage, $cnum[0]['CNT'], $ustr  );

		// GET string (ܺٲ̤ؤΰѤ)
		$this->mCndStr = $cndstr;
		if( xoops_getrequest('cond_perpage')		){ $this->mCndStr .= "&cond_perpage="	. xoops_getrequest('cond_perpage'); }
		if( xoops_getrequest('cond_start')			){ $this->mCndStr .= "&cond_start="		. xoops_getrequest('cond_start'); }

		// ̾Хåƥ꡼ʸĹtruncate롣ϤƤ륤˥󥰤ϺǸޤɽ롣
		foreach( $this->mGameList as &$dat ){
			$ingmax = _BBSB_OP_GAME_DISPINNINGS;
			$dat['DispInnings'] = $ingmax;
			if( mb_strlen($dat['FirstTeamName']) > 10 ){
				$dat['FirstTeamName'] = mb_substr( $dat['FirstTeamName'], 0, 10) . "...";
			}
			if( mb_strlen($dat['LastTeamName']) > 10 ){
				$dat['LastTeamName'] = mb_substr( $dat['LastTeamName'], 0, 10) . "...";
			}
			if( mb_strlen($dat['FirstBattery']) > 17 ){
				$dat['FirstBattery'] = mb_substr( $dat['FirstBattery'], 0, 17) . "...";
			}
			if( mb_strlen($dat['LastBattery']) > 17 ){
				$dat['LastBattery'] = mb_substr( $dat['LastBattery'], 0, 17) . "...";
			}
			if( $dat['Itop'][$ingmax] !== null ){
				for( $icnt = _BBSB_OP_GAME_DISPINNINGS ; $icnt < 25 ; $icnt++ ){
					if( $dat['Itop'][$icnt] !== null ){
						$ingmax = $icnt;
						continue;
					}
				}
				$dat['DispInnings'] = $ingmax;	// ǽ˥󥰤
			}
			for( $icnt = $dat['DispInnings'] ; $icnt < 25 ; $icnt++ ){	// ǽ˥󥰰ʹߤunset
				unset($dat['Itop'][$icnt]);
				unset($dat['Ibottom'][$icnt]);
			}
			// Result ""/""/"ʬ"̤
			if( ($dat['Result'] % 10) == 0 ){
				$dat['ResultStr'] = "Lose";
			} else if( ($dat['Result'] % 10) == 1 ){
				$dat['ResultStr'] = "Win";
			} else if( $dat['Result'] % 10 == 2 ){
				$dat['ResultStr'] = "Even";
			} else {
				$dat['ResultStr'] = "";
			}
		}

		// //ʬ ׿μ
		$Otlst = array();
		$sqlstr =	" SELECT CASE WHEN Result IN ('0','10','20','30') THEN 'Lose'";
		$sqlstr .=	"             WHEN Result IN ('1','11','21','31') THEN 'Win'";
		$sqlstr .=	"             WHEN Result IN ('2') THEN 'Even'";
		$sqlstr .=	"             ELSE 'Etc'";
		$sqlstr .=	"        END AS ResultSummary,  count(*) AS COUNT ";
		$sqlstr .=	" FROM " . $dbGame->prefix_dir('bb_game') . " G ";
		$sqlstr =	$sqlstr . $wherestr . " GROUP BY ResultSummary ";
		//$this->mResultSummary	= $dbGame->getList( $sqlstr );
		$Otlst  = 	$dbGame->getList( $sqlstr );
		foreach( $Otlst as $key => $value ){
			$rslt = $value['ResultSummary'];
			$this->mResultSummary[$rslt] += $value['COUNT'];
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewgamelistM.html");		// Mobile
		} else {
			$render->setTemplateName("bbsb_viewgamelist.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE . _BBSB_OP_BBSB_COMMON_JS);
		}
		$render->setAttribute("actionForm", $this->mActionForm);

		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		$render->setAttribute('adminmode',		$adminmode);			// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å

		// 쥯ȥܥå
		$render->setAttribute("nendolist",		$this->mNendoList);		// ǯ٥쥯ȥܥå
		$montharray = array("1","2","3","4","5","6","7","8","9","10","11","12");
		$render->setAttribute("months",			$montharray);			// Υ쥯ȥܥå
		$render->setAttribute("leaguelist", 	$this->mLeagueList);	// ꡼
		$render->setAttribute("tournamentlist",	$this->mTournamentList);// ȡʥ
		$render->setAttribute("gameorderlist",	$this->mGameOrderList);	// 
		$render->setAttribute("groundlist",		$this->mGroundList);	// 饦
		$render->setAttribute("opponentlist",	$this->mOpponentList);	// 
		$render->setAttribute("ownteamlist",	$this->mOwnTeamList);	// ̾

		// //ʬ ׿
//		$WinSum = $LoseSum = $EvenSum = 0;
//		foreach( $this->mResultSummary as $key => $value ){
//			if( $value['ResultSummary'] == 'Win' ){
//				$WinSum = $value['COUNT'];
//			} else if( $value['ResultSummary'] == 'Lose' ){
//				$LoseSum = $value['COUNT'];
//			} else if( $value['ResultSummary'] == 'Even' ){
//				$EvenSum = $value['COUNT'];
//			}
//		}
//		$render->setAttribute('WinSum',		$WinSum );
//		$render->setAttribute('LoseSum',	$LoseSum );
//		$render->setAttribute('EvenSum',	$EvenSum );
		$render->setAttribute('ResultSummary',		$this->mResultSummary );

		$render->setAttribute('gameList',	$this->mGameList );			// ǡ
		$render->setAttribute('cndstr',		$this->mCndStr );			// string
		$render->setAttribute('pagenavi',	$this->mPageNavi );			// ڡʥӾ

		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_VIEWGAMELIST') );
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}
}
?>