<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * ưͽ
 */
class BBSB_ViewSchedulelistAction extends BBSB_AbstractEditAction
{
	var $mYearList			= array();	// ǯ٥쥯ȥܥåǡ
	var $mTournamentList	= array();	// /ȡʥȥ쥯ȥܥåǡ
	var $mGroundList		= array();	// 饦ɥ쥯ȥܥåǡ
	var $mOpponentList		= array();	// ꥻ쥯ȥܥåǡ
	var $mScheList			= array();	// 塼ǡ
	var $mDelMsg			= null;		// 쥳ɺå
	var $mPageNavi			= array();	// PageNavi

	function __construct($mydirname){
		parent::__construct($mydirname);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/AbstractDatabase.class.php";
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/class/DbSchedule.class.php";
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ưͽ굡ǽȤʤϽλ
		if( !_BBSB_OP_DISPSCHE && !is_object($root->mContext->mXoopsUser) ){
			$controller->executeForward("./index.php");
		}

		// Хб
		if (class_exists('Wizin_User')) {	//Wizmobile
			$mobile_user = & Wizin_User::getSingleton();
			$this->mMobile = $mobile_user->bIsMobile;
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbSch = new BBSB_DbSchedule($this->mMyDirName);

		// WHERE
		$wherestr = $this->createScheWhereStrForSearch();
		// ڡּ
		if( !xoops_getrequest('cond_start') && !xoops_getrequest('cond_perpage') ){
			// PageNaviѤλ꤬ʤ0ܤ100Լ(PCξ)
			$startrow	= 0;
			$perpage	= $this->mMobile? _BBSB_PAGENAVI_PERPAGE_M : _BBSB_PAGENAVI_PERPAGE;
		} else {
			$startrow	= intval(xoops_getrequest('cond_start'));
			$perpage	= xoops_getrequest('cond_perpage');
		}
		$lstr = $startrow . "," . $perpage;
		// 塼ꥹȼ
		$this->mScheList = $dbSch->getScheduleList( $wherestr, "DESC", $lstr );
		// ׷
		$cnum = $dbSch->getList( "SELECT FOUND_ROWS() AS CNT" );

		// pagenavi
		$ustr = _BBSB_MODULE_URL . "index.php?action=ViewSchedulelist";
		if( xoops_getrequest('year')		){ $ustr .= "&year="			. xoops_getrequest('year'); }
		if( xoops_getrequest('month')		){ $ustr .= "&month="			. xoops_getrequest('month'); }
		if( xoops_getrequest('tournamentid')){ $ustr .= "&tournamentid="	. xoops_getrequest('tournamentid'); }
		if( xoops_getrequest('groundid')	){ $ustr .= "&groundid="		. xoops_getrequest('groundid'); }
		if( xoops_getrequest('opponentid')	){ $ustr .= "&opponentid="		. xoops_getrequest('opponentid'); }
		$ustr .= "&cond_perpage=" . $perpage;
		$this->mPageNavi = $this->setPageNavi( $startrow, $perpage, $cnum[0]['CNT'], $ustr  );

		// ǡβù
		if( $this->mScheList ){
			foreach( $this->mScheList as $key => &$dat ){
				// ٥ȼ
				$enum	=  $dat['EventKind'];
				$dat['EventKind']	= $this->getEventKindStr( $enum );
				$dat['EventKindID']	= $this->getEventKindID( $enum );
				// ʸ
				$dat['EventDate'] = $this->getDateStr( $dat['EventYear'], $dat['EventMonth'], $dat['EventDay'], $dat['EventHour'], $dat['EventMinute']);
				// դ̤Υ٥ȤɤĴ٤롣(Υ٥Ȥ϶Ĵɽ뤿)
				$dat['Comming'] = false;
				$edate = sprintf("%d%02d%02d", $dat['EventYear'], $dat['EventMonth'], $dat['EventDay'] );
				if( strcmp($edate, date("Ymd")) >= 0 ){
					$dat['Comming'] = true;
				}
			}
		}

		$this->mYearList		= $dbSch->getSelectYearList();			// ǯꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $dbSch->getSelectSTournamentList();	// /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $this->truncatestr( $this->mTournamentList, 'TournamentName', 19 );
		$this->mGroundList		= $dbSch->getSelectSGroundList();		// 饦ɥꥹȼ(쥳ɤ¸ߤ륰饦ɤΤ߼ǯ٥ꥹȤȤ)
		$this->mGroundList		= $this->truncatestr( $this->mGroundList, 'GroundName', 19 );
		$this->mOpponentList	= $dbSch->getSelectSOpponentList();		// ꥹȼ(쥳ɤ¸ߤΤ߼ǯ٥ꥹȤȤ)
		$this->mOpponentList	= $this->truncatestr( $this->mOpponentList, 'TeamName', 19 );
		// νͤ-1
		if( xoops_getrequest('opponentid') === null ){
			$_GET['opponentid']='-1';
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		if( $this->mMobile ){
			$render->setTemplateName("bbsb_viewschedulelistM.html");	// Mobile
		} else {
			$render->setTemplateName("bbsb_viewschedulelist.html");
			$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);
		}

		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		$render->setAttribute('adminmode',		$adminmode);			// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å

		// 쥯ȥܥå
		$render->setAttribute("years",			$this->mYearList);		// ǯ쥯ȥܥå
		$montharray = array("1","2","3","4","5","6","7","8","9","10","11","12");
		$render->setAttribute("months",			$montharray);			// Υ쥯ȥܥå
		$render->setAttribute("tournamentlist",	$this->mTournamentList);// ȡʥ
		$render->setAttribute("groundlist",		$this->mGroundList);	// 饦
		$render->setAttribute("opponentlist",	$this->mOpponentList);	// 

		$render->setAttribute('scheList',	$this->mScheList );			// 塼ǡ
		$render->setAttribute('pagenavi',	$this->mPageNavi );			// ڡʥӾ
		$render->setAttribute('modname',	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute('submenu',	constant($this->mConstPref . '_MENU_SCHEDULE') );
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * ʤWHERE(塼)
	 * bb_scheduleơ֥̾'S'ȤSQLȤळȡ
	 * @return unknown_type
	 */
	function createScheWhereStrForSearch()
	{
		$wherestr = "";
		// ǯ
		$year = xoops_getrequest('year');
		if( $year ){
			if( $year == date("Y") ){	// ǯƱǯꤵƤϡǯʹߤξʬͽޤ
				$cmpchar = ">=";
			} else {
				$cmpchar = "=";
			}
			$wherestr .= "EventYear" . $cmpchar . "'" . $year . "'";
		}
		// ȡʥID饦ID
		$wherearray = array('EventMonth'		=> 'month',
							'S.TournamentID'	=> 'tournamentid',
							'S.GroundID'		=> 'groundid' );
		foreach( $wherearray as $key => $value ){
			if( xoops_getrequest($value) ){
				if( $wherestr ){
					$wherestr .= " AND ";
				}
				$wherestr .= $key . "='" . xoops_getrequest($value) . "'";
			}
		}
		// 
		if( xoops_getrequest('opponentid') != null  && xoops_getrequest('opponentid') != '-1' ){			// opponentid = -1 ΤȤ̤֤ʤΤWehreȤʤ
			if( $wherestr ){
				$wherestr .= " AND ";
			}
			$teamid = xoops_getrequest('opponentid');
			$wherestr .= " (Opponent1='" . $teamid . "' "
						. " OR Opponent2='" . $teamid . "' "
						. " OR Opponent3='" . $teamid . "') ";
		}
		if( $wherestr ){
			$wherestr = " WHERE " . $wherestr;
		}
		return $wherestr;
	}

}
?>