<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_LEGACY_PATH . "/class/ActionFrame.class.php";										// Legacy ե졼
require_once XOOPS_LEGACY_PATH . "/admin/actions/ModuleUpdateAction.class.php";							// Legacy ⥸塼륢åץǡȥ饹

/*
 * ԡ󥯥ååץǡȽ
 */
class BBSB_AutoUpdateAction extends Legacy_ModuleUpdateAction
{
	var $mErrMsg			= null;		// 顼å
	var $mFileOwner			= null;		// ե륪ʡ
	var $mActionForm		= null;		// ե।󥹥󥹡see _setupActionForm()

	function __construct($mydirname, $flag){
		parent::Legacy_ModuleUpdateAction($flag);
		require_once XOOPS_MODULE_PATH . "/" . $mydirname . "/admin/forms/AdminCheckVersionForm.class.php";	// ե९饹
	}

	/**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm = new BBSB_CheckVersionForm($this->mMyDirName);		// ֺǿСγǧץեƱͤȤ롣
		$this->mActionForm->prepare();
	}

	function &_getInstaller()
	{
		return parent::_getInstaller();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);

		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}

		// FileOwner
		$userinfo = posix_getpwuid(fileowner(_BBSB_MODULE_PATH . "index.php"));
		$this->mFileOwner = $userinfo['name'];
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		return BBSB_FRAME_VIEW_ERROR;
	}

	/**
	 * XOOPSåץǡȽ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		if(xoops_getrequest('update')){
			// XOOPS åץǡ
			$this->mInstaller->executeUpgrade();
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
	}

	/**
	 * ɽ
	 * @see modules/legacy/admin/actions/Legacy_ModuleUpdateAction#executeViewSuccess($controller, $xoopsUser, $renderer)
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		if (!$this->mInstaller->mLog->hasError()) {
			$this->mUpdateSuccess->call(new XCube_Ref($this->mXoopsModule), new XCube_Ref($this->mInstaller->mLog));
			XCube_DelegateUtils::call('Legacy.Admin.Event.ModuleUpdate.' . ucfirst($this->mXoopsModule->get('dirname') . '.Success'), new XCube_Ref($this->mXoopsModule), new XCube_Ref($this->mInstaller->mLog));
		}
		else {
			$this->mUpdateFail->call(new XCube_Ref($this->mXoopsModule), new XCube_Ref($this->mInstaller->mLog));
			XCube_DelegateUtils::call('Legacy.Admin.Event.ModuleUpdate.' . ucfirst($this->mXoopsModule->get('dirname') . '.Fail'), new XCube_Ref($this->mXoopsModule), new XCube_Ref($this->mInstaller->mLog));
		}

		$render->setTemplateName("admin_autoupdate.html");
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute('log', $this->mInstaller->mLog->mMessages);
		$render->setAttribute("modname",	$controller->mRoot->mContext->mModule->mXoopsModule->get('name'));
		$render->setAttribute("submenu",	constant($this->mConstPref . '_ADMENU_UPDATEMODULE') );
	}

	/**
	 * Ի
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
	}

	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
	}
}
?>
