<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/***
 * եࡧǡܹ
 */
class BBSB_SwitchOverForm extends XCube_ActionForm
{
	var $mInfoMessages = array();	// ϥå
	var	$mMyDirName	= null;			// ⥸塼ǥ쥯ȥ̾

	function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
	}

	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['websbpath']		= new XCube_StringProperty('websbpath');	// websbؤΥѥ̾
		$this->mFormProperties['method']		= new XCube_StringProperty('method');		// ܹˡ
		$this->mFormProperties['ikzurl']		= new XCube_StringProperty('ikzurl');		// ֹԤHPURL
		$this->mFormProperties['ikzpass']		= new XCube_StringProperty('ikzpass');		// ֹԤ״ѥ
		$this->mFormProperties['ikzcourse']		= new XCube_IntProperty('ikzcourse');		// 󥳡
		$this->mFormProperties['RefineYear']	= new XCube_StringProperty('RefineYear');	// ֹԤװܹԻιʤǯ
		$this->mFormProperties['RefineMonth']	= new XCube_StringProperty('RefineMonth');	// ֹԤװܹԻιʤ߷

		// եɥץѥƥ
		// Web֥åؤΥѥ
		$this->mFieldProperties['websbpath']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['websbpath']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['websbpath']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_SCOREBOOKPATH, '256');
		$this->mFieldProperties['websbpath']->addVar('maxlength', 256);

		// ֹԤHPURL
		$this->mFieldProperties['ikzurl']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['ikzurl']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['ikzurl']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_AD_BBSB_ADMENU_SO_IKZURL, '256');
		$this->mFieldProperties['ikzurl']->addVar('maxlength', 256);

		// ֹԤ״ѥ
		$this->mFieldProperties['ikzpass']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['ikzpass']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['ikzpass']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_AD_BBSB_ADMENU_SO_IKZPASS, '256');
		$this->mFieldProperties['ikzpass']->addVar('maxlength', 256);

		// 󥳡
		$this->mFieldProperties['ikzcourse']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['ikzcourse']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['ikzcourse']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_AD_BBSB_ADMENU_SO_IKZCOURSE, "1");
		$this->mFieldProperties['ikzcourse']->addMessage('intRange',_MD_BBSB_ERROR_INTRANGE,	_AD_BBSB_ADMENU_SO_IKZCOURSE);
		$this->mFieldProperties['ikzcourse']->addVar('maxlength', 1);
		$this->mFieldProperties['ikzcourse']->addVar('min', '1');
		$this->mFieldProperties['ikzcourse']->addVar('max', '2');

		// ֹԤװܹԻιʤǯ
		$this->mFieldProperties['RefineYear']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['RefineYear']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['RefineYear']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_AD_BBSB_ADMENU_SO_IKZPASS, '4');
		$this->mFieldProperties['RefineYear']->addVar('maxlength', 4);

		// ֹԤװܹԻιʤ߷
		$this->mFieldProperties['RefineMonth']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['RefineMonth']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['RefineMonth']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_AD_BBSB_ADMENU_SO_IKZPASS, '2');
		$this->mFieldProperties['RefineMonth']->addVar('maxlength', 2);
	}

	// 
	function load(&$obj)
	{
	}

	/**
	 * ϥå뤫ɤȽؿ
	 * @return unknown_type
	 */
	function hasInfoMsg()
	{
		return (count($this->mInfoMessages) > 0);
	}

	/**
	 * @protected
	 * @brief Adds an message to error message buffer of the form.
	 * @param $message string
	 */
	function addInfoMessage($message)
	{
		$this->mInfoMessages[] = $message;
	}

	/**
	 * @public
	 * @brief Gets error messages.
	 * @return string[]
	 */
	function getInfoMessages()
	{
		return $this->mInfoMessages;
	}
}
?>
