<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

/**
 * FTP 饹
 */
class BBSB_FTP
{
	var $mCID;		// ConnectID

    function __construct() {
    }

	/**
	 * FTP ͥ&
	 * @return unknown_type
	 */
	function connect( $user, $pass )
	{
		// ͥ
		$this->mCID = ftp_connect(_BBSB_OP_FTPSERVER);
		if( !$this->mCID ){
			return false;
		}
		// 
		$ret = ftp_login($this->mCID, $user, $pass);	// 桼̾ȥѥɤǥ󤹤
		if( !$ret ){
			return false;
		}

		ftp_pasv( $this->mCID, true );

		return true;
	}

	/**
	 * ǥ쥯ȥư
	 * @param $dirname	ưǥ쥯ȥ
	 * @return unknown_type
	 */
	function chDir( $dirname )
	{
		if( !ftp_chdir($this->mCID, $dirname) ) {
			return false;
		}
		return true;
	}

	/**
	 * setting.ini
	 * @param $actionForm	ե४֥
	 * @param $inifile		ե̾
	 * @return iniե󡣼Ԥξfalse
	 */
	function getSetting( $actionForm, $inifile )
	{
		chdir(_BBSB_MODULE_UPLOAD_IMAGE_PATH);		// Υե֤(uploads)ذư

		// ftp eet
		$ret = ftp_get($this->mCID, $inifile, $inifile, FTP_BINARY);
		if( !$ret ){
			$actionForm->addErrorMessage( _MD_BBSB_ERROR_FTPERROR . ":GET failed. [" . $inifile . "]" );
			return false;
		}

		// setting.iniեɤ߹ߥѡ
		$ret = parse_ini_file($inifile);
		return $ret;
	}

	/**
	 * FTP ǥե(֥ǥ쥯ȥо)
	 * @param $actionForm	ե४֥
	 * @param $user			ftpGETȡǥ쥯ȥOwnerѹ뤿Υ桼 (SafeModeб)
	 * @param $dir			եǥ쥯ȥ(Dirξ".")
	 * @param $log			֥
	 * @return true: false
	 */
	function syncFiles( $actionForm, $httpduser, $user, $dir , $log )
	{
		if ($dir != ".") {
			$ret = ftp_chdir($this->mCID, $dir);
			if( !$ret ){
				$actionForm->addErrorMessage( _MD_BBSB_ERROR_FTPERROR . ":ftp_chdir [" . $dir . "]");
				return false;
			}
			if( !(is_dir($dir)) ){
				umask(0);
				$ret = mkdir($dir, 0777);
				if( !$ret ){
					$actionForm->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_MKDIR, $dir));
					rmdir($dir);
					return false;
				}
				$log->versionuplog("[sh] mkdir " . $dir);
			}
			chdir( $dir );
			// ǥ쥯ȥΥʡѹ
			$str = $out = "";
			$cmd = _BBSB_OP_UPDATESHELL . " chown " . $httpduser . " " . $user . " " . getcwd();
			$str = exec( $cmd, $out, $ret );
			$log->versionuplog("[sh] " . $cmd);
			$log->versionuplog($out);
			$log->versionuplog("[sh] ret=" . $ret);
			if( $ret ){
				$actionForm->addErrorMessage( _MD_BBSB_ERROR_CHOWN . ":" . $httpduser . " to " . $user . ":[" . basename(getcwd()) . "]" );
				chdir ('../');
				rmdir($dir);
				return false;
			}
		}

		$buff = ftp_rawlist( $this->mCID, "." );
		foreach ($buff as $row) {
			$fileinf = preg_split("/[\s]+/", $row, 9);
			if ($fileinf[8] == '.' || $fileinf[8] == '..' ){	// $fileinf[8] ϥե(ǥ쥯ȥ)̾
				continue;
			}
			if( substr( $fileinf[0], 0 ,1 ) == 'd' ){			// ǥ쥯ȥΤȤ
				$ret = $this->syncFiles ( $actionForm, $httpduser, $user, $fileinf[8], $log );
				if( !$ret ){
					return false;
				}
			} else {											// եΤȤ
				$ret = ftp_get($this->mCID, $fileinf[8], $fileinf[8], FTP_BINARY);
				$log->versionuplog("[ftp get] " . $fileinf[8] . ", ret=[" . $ret . "]");
				if( !$ret ){
					$actionForm->addErrorMessage( _MD_BBSB_ERROR_FTPERROR . ":GET failed. [" . $fileinf[8] . "]" );
					return false;
				}
			}
		}

		ftp_chdir ($this->mCID, "..");
		chdir ("..");

		return true;
	}

	/**
	 * FTP 
	 * @return unknown_type
	 */
	function close()
	{
		 ftp_close($this->mCID);
	}
}
?>