<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/**
 * եࡧϿ(Mobileѻ绲üϿ)
 */
class BBSB_EditGamedetailMentForm extends XCube_ActionForm
{
	var	$mMyDirName	= null;		// ⥸塼ǥ쥯ȥ̾
    function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
		require_once XOOPS_MODULE_PATH . "/" . $this->mMyDirName . "/class/DbMember.class.php";
    }

    function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['gid']				= new XCube_IntProperty('gid');				// ID
		$this->mFormProperties['playorder']			= new XCube_IntArrayProperty('playorder');		// ǽ
		$this->mFormProperties['changecnt']			= new XCube_IntArrayProperty('changecnt');		// ȯ/
		$this->mFormProperties['uniformno']			= new XCube_StringArrayProperty('uniformno');	// ֹ
		$this->mFormProperties['position1']			= new XCube_IntArrayProperty('position1');		// ݥ1
		$this->mFormProperties['position2']			= new XCube_IntArrayProperty('position2');		// ݥ2
		$this->mFormProperties['stolenbasesuc']		= new XCube_IntArrayProperty('stolenbasesuc');	// 
		$this->mFormProperties['stolenbasefail']	= new XCube_IntArrayProperty('stolenbasefail');// 
		$this->mFormProperties['runscnt']			= new XCube_IntArrayProperty('runscnt');		// 
		$this->mFormProperties['errorscnt']			= new XCube_IntArrayProperty('errorscnt');		// 
		$this->mFormProperties['winningrun']		= new XCube_BoolArrayProperty('winningrun');	// 

		// ID
		$this->mFieldProperties['gid']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['gid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['gid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEID, "5");
		$this->mFieldProperties['gid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEID);
		$this->mFieldProperties['gid']->addVar('maxlength', 5);
		$this->mFieldProperties['gid']->addVar('min', '1');
		$this->mFieldProperties['gid']->addVar('max', '32767');
		// ǽ
		$this->mFieldProperties['playorder']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['playorder']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['playorder']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PLAYORDER, "2");
		$this->mFieldProperties['playorder']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PLAYORDER);
		$this->mFieldProperties['playorder']->addVar('maxlength', 2);
		$this->mFieldProperties['playorder']->addVar('min', '1');
		$this->mFieldProperties['playorder']->addVar('max', '15');
		// ȯ/
		$this->mFieldProperties['changecnt']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['changecnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['changecnt']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_CHANGECNT, "2");
		$this->mFieldProperties['changecnt']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_CHANGECNT);
		$this->mFieldProperties['changecnt']->addVar('maxlength', 2);
		$this->mFieldProperties['changecnt']->addVar('min', '0');
		$this->mFieldProperties['changecnt']->addVar('max', '99');
		// ֹ
		$this->mFieldProperties['uniformno']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['uniformno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['uniformno']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_UNIFORMNO, "5");
		$this->mFieldProperties['uniformno']->addVar('maxlength', 5);
		// ݥ1
		$this->mFieldProperties['position1']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['position1']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position1']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position1']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position1']->addVar('maxlength', 1);
		$this->mFieldProperties['position1']->addVar('min', '1');
		$this->mFieldProperties['position1']->addVar('max', '9');
		// ݥ2
		$this->mFieldProperties['position2']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['position2']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['position2']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_POSITION, "1");
		$this->mFieldProperties['position2']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_POSITION);
		$this->mFieldProperties['position2']->addVar('maxlength', 1);
		$this->mFieldProperties['position2']->addVar('min', '1');
		$this->mFieldProperties['position2']->addVar('max', '9');
		// 
		$this->mFieldProperties['stolenbasesuc']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['stolenbasesuc']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['stolenbasesuc']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_STOLENBASESUC, "2");
		$this->mFieldProperties['stolenbasesuc']->addMessage('intRange',_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_STOLENBASESUC);
		$this->mFieldProperties['stolenbasesuc']->addVar('maxlength', 2);
		$this->mFieldProperties['stolenbasesuc']->addVar('min', '0');
		$this->mFieldProperties['stolenbasesuc']->addVar('max', '99');
		// 
		$this->mFieldProperties['stolenbasefail']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['stolenbasefail']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['stolenbasefail']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_STOLENBASEFAIL, "2");
		$this->mFieldProperties['stolenbasefail']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_STOLENBASEFAIL);
		$this->mFieldProperties['stolenbasefail']->addVar('maxlength', 2);
		$this->mFieldProperties['stolenbasefail']->addVar('min', '0');
		$this->mFieldProperties['stolenbasefail']->addVar('max', '99');
		// 
		$this->mFieldProperties['runscnt']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['runscnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['runscnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_RUNSCNT, "2");
		$this->mFieldProperties['runscnt']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_RUNSCNT);
		$this->mFieldProperties['runscnt']->addVar('maxlength', 2);
		$this->mFieldProperties['runscnt']->addVar('min', '0');
		$this->mFieldProperties['runscnt']->addVar('max', '99');
		// 
		$this->mFieldProperties['errorscnt']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['errorscnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['errorscnt']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_ERRORSCNT, "2");
		$this->mFieldProperties['errorscnt']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_ERRORSCNT);
		$this->mFieldProperties['errorscnt']->addVar('maxlength', 2);
		$this->mFieldProperties['errorscnt']->addVar('min', '0');
		$this->mFieldProperties['errorscnt']->addVar('max', '99');
		// 
		$this->mFieldProperties['winningrun']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['winningrun']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['winningrun']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_WINNINGRUN_S, "1");
		$this->mFieldProperties['winningrun']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_WINNINGRUN_S);
		$this->mFieldProperties['winningrun']->addVar('maxlength', 1);
		$this->mFieldProperties['winningrun']->addVar('min', '0');
		$this->mFieldProperties['winningrun']->addVar('max', '1');

	}

	/**
	 * ǽ硢 ϥå
	 * @return unknown_type
	 *	Ʊǽ硢ΥåȤ2İʾ¸ߤʤȡ
	 */
	function validateChangecnt()
	{
		$plist = array();
		$clist = array();
		$plist = $this->get('playorder');
		$clist = $this->get('changecnt');
		array_multisort( $plist, $clist);
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM -1 ; $rcnt++ ){
			if( $plist[$rcnt+1] == "" ){continue;}	// ǽ礬äƤʤ쥳ɤ̵
			if( $plist[$rcnt] ==  $plist[$rcnt+1] && $clist[$rcnt] == $clist[$rcnt+1] ){
				$this->addErrorMessage(_MD_BBSB_ERROR_DUPLICATEORDER);
				return;
			}
		}
	}

	/**
	 * ǽ硢˥եNo ϥå
	 * @return unknown_type
	 *	ǷǡϿȤϡǽ̾ȥåȤƤʤФʤʤ
	 *	ޤ̾ϽʣƤϤʤ
	 */
	function validateUniformNo()
	{
		$plist = array();
		$mlist = array();
		$plist = $this->get('playorder');
		$mlist = $this->get('uniformno');

		// ¸ߤֹǤ뤳ȡ
		$uid = array();
		$dbM = new BBSB_DbMember($this->mMyDirName);
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM ; $rcnt++ ){
			if( $mlist[$rcnt] === "" ){ continue; }
			$dbM->unsetData();
			$dbM->setData( 'UniformNo',	$mlist[$rcnt] );
			$dbM->setOrderBy( 'UserID', 'ASC' );
			$uid = $dbM->getListbyCond('bb_member','UserID', 1);
			if( $uid[0]['UserID'] === null ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_UNONOTFOUND, $mlist[$rcnt]));
			}
		}

		for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM ; $rcnt++ ){
			if( ( $plist[$rcnt] == "" && $mlist[$rcnt] != "" ) ||
				( $plist[$rcnt] != "" && $mlist[$rcnt] == "" ) ){
				$this->addErrorMessage(_MD_BBSB_ERROR_ORDERASUNO);
				return;
			}
		}
		// ֹʣå
		sort($mlist);	// 
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_BATTERS_ROWNUM-1 ; $rcnt++ ){
			if( $mlist[$rcnt]==0 ) {continue;}
			if( $mlist[$rcnt] == $mlist[$rcnt+1] ){
				$this->addErrorMessage(_MD_BBSB_ERROR_DUPLICATEUNO);
				return;
			}
		}
	}

	/**
	 * ե ϥå
	 * @return unknown_type
	 */
	function validateWinningRun()
	{
		$dlist = array();
		$dlist = $this->get('winningrun');
		if( count($dlist) > 1 ){
			$this->addErrorMessage(_MD_BBSB_ERROR_WINNINGRUN);
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
