<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/**
 * եࡧ˥ǷϿ(MobileǷϿ)
 */
class BBSB_EditGamedetailMinnForm extends XCube_ActionForm
{
	var	$mMyDirName	= null;		// ⥸塼ǥ쥯ȥ̾
    function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
		require_once XOOPS_MODULE_PATH . "/" . $this->mMyDirName . "/class/DbGame.class.php";
    }

    function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['gid']				= new XCube_IntProperty('gid');				// ID
		$this->mFormProperties['inning']			= new XCube_IntProperty('inning');				// ˥
		$this->mFormProperties['userid']			= new XCube_IntProperty('userid');				// ˥
//		$this->mFormProperties['playorder']			= new XCube_IntArrayProperty('playorder');		// ǽ
//		$this->mFormProperties['changecnt']			= new XCube_IntArrayProperty('changecnt');		// ȯ/
		$this->mFormProperties['userid']			= new XCube_IntArrayProperty('userid');		// ID
		$this->mFormProperties['stolenbasesuc']		= new XCube_IntArrayProperty('stolenbasesuc');	// 
		$this->mFormProperties['stolenbasefail']	= new XCube_IntArrayProperty('stolenbasefail');// 
		$this->mFormProperties['runscnt']			= new XCube_IntArrayProperty('runscnt');		// 
		$this->mFormProperties['scoremarkid']		= new XCube_StringArrayProperty('scoremark');	// Ƿ
		$this->mFormProperties['direction']			= new XCube_StringArrayProperty('direction');	// ǵ
		$this->mFormProperties['rbi']				= new XCube_StringArrayProperty('rbi');		// 

		// ID
		$this->mFieldProperties['gid']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['gid']->setDependsByArray(array('required','maxlength','intRange'));
		$this->mFieldProperties['gid']->addMessage('required',			_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_GAMEID);
		$this->mFieldProperties['gid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEID, "5");
		$this->mFieldProperties['gid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEID);
		$this->mFieldProperties['gid']->addVar('maxlength', 5);
		$this->mFieldProperties['gid']->addVar('min', '1');
		$this->mFieldProperties['gid']->addVar('max', '32767');
		// ˥
		$this->mFieldProperties['inning']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['inning']->setDependsByArray(array('required','maxlength','intRange'));
		$this->mFieldProperties['inning']->addMessage('required',		_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_INNINGHEADER);
		$this->mFieldProperties['inning']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_INNINGHEADER, "2");
		$this->mFieldProperties['inning']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_INNINGHEADER);
		$this->mFieldProperties['inning']->addVar('maxlength', 2);
		$this->mFieldProperties['inning']->addVar('min', '1');
		$this->mFieldProperties['inning']->addVar('max', '99');
		// 桼ID
		$this->mFieldProperties['userid']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['userid']->setDependsByArray(array('required','maxlength','intRange'));
		$this->mFieldProperties['userid']->addMessage('required',		_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_PLAYMEMBER);
		$this->mFieldProperties['userid']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PLAYMEMBER, "5");
		$this->mFieldProperties['userid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PLAYMEMBER);
		$this->mFieldProperties['userid']->addVar('maxlength', 5);
		$this->mFieldProperties['userid']->addVar('min', '1');
		$this->mFieldProperties['userid']->addVar('max', '32767');
//		// ǽ
//		$this->mFieldProperties['playorder']		= new XCube_FieldProperty($this);
//		$this->mFieldProperties['playorder']->setDependsByArray(array('maxlength','intRange'));
//		$this->mFieldProperties['playorder']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PLAYORDER, "2");
//		$this->mFieldProperties['playorder']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PLAYORDER);
//		$this->mFieldProperties['playorder']->addVar('maxlength', 2);
//		$this->mFieldProperties['playorder']->addVar('min', '1');
//		$this->mFieldProperties['playorder']->addVar('max', '15');
//		// ȯ/
//		$this->mFieldProperties['changecnt']		= new XCube_FieldProperty($this);
//		$this->mFieldProperties['changecnt']->setDependsByArray(array('maxlength','intRange'));
//		$this->mFieldProperties['changecnt']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_CHANGECNT, "2");
//		$this->mFieldProperties['changecnt']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_CHANGECNT);
//		$this->mFieldProperties['changecnt']->addVar('maxlength', 2);
//		$this->mFieldProperties['changecnt']->addVar('min', '0');
//		$this->mFieldProperties['changecnt']->addVar('max', '99');
		// ID
		$this->mFieldProperties['userid']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['userid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['userid']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PLAYMEMBER, "5");
		$this->mFieldProperties['userid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PLAYMEMBER);
		$this->mFieldProperties['userid']->addVar('maxlength', 5);
		$this->mFieldProperties['userid']->addVar('min', '0');
		$this->mFieldProperties['userid']->addVar('max', '32767');
		// 
		$this->mFieldProperties['stolenbasesuc']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['stolenbasesuc']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['stolenbasesuc']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_STOLENBASESUC, "2");
		$this->mFieldProperties['stolenbasesuc']->addMessage('intRange',_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_STOLENBASESUC);
		$this->mFieldProperties['stolenbasesuc']->addVar('maxlength', 2);
		$this->mFieldProperties['stolenbasesuc']->addVar('min', '0');
		$this->mFieldProperties['stolenbasesuc']->addVar('max', '99');
		// 
		$this->mFieldProperties['stolenbasefail']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['stolenbasefail']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['stolenbasefail']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_STOLENBASEFAIL, "2");
		$this->mFieldProperties['stolenbasefail']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_STOLENBASEFAIL);
		$this->mFieldProperties['stolenbasefail']->addVar('maxlength', 2);
		$this->mFieldProperties['stolenbasefail']->addVar('min', '0');
		$this->mFieldProperties['stolenbasefail']->addVar('max', '99');
		// 
		$this->mFieldProperties['runscnt']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['runscnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['runscnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_RUNSCNT, "2");
		$this->mFieldProperties['runscnt']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_RUNSCNT);
		$this->mFieldProperties['runscnt']->addVar('maxlength', 2);
		$this->mFieldProperties['runscnt']->addVar('min', '0');
		$this->mFieldProperties['runscnt']->addVar('max', '99');

	}

	/**
	 * Ƿե ϥå
	 * @return unknown_type
	 */
	function validateScoremark()
	{
		$list = array();
		$list = $this->get('scoremarkid');
		for( $rcnt = 0 ; $rcnt < count($list) ; $rcnt++ ){
			if( strlen($list[$rcnt]) > 2 ){
				$msg =  $list[$rcnt] . _MD_BBSB_ERROR_BATSCORE2_SCOREMARK;
				$this->addErrorMessage($msg);
			}
		}
	}

	/**
	 * Ƿե ϥå
	 * @return unknown_type
	 */
	function validateDirection()
	{
		$list = array();
		$list = $this->get('direction');
		for( $rcnt = 0 ; $rcnt < count($list) ; $rcnt++ ){
			if( $list[$rcnt] != "" &&
				intval($list[$rcnt]) < 1 || 9 < intval($list[$rcnt]) ){
				$msg = $list[$rcnt] . _MD_BBSB_ERROR_BATSCORE2_DIR;
				$this->addErrorMessage($msg);
			}
		}
	}

	/**
	 * ե ϥå
	 * @return unknown_type
	 */
	function validateRbi()
	{
		$list = array();
		$list = $this->get('rbi');
		for( $rcnt = 0 ; $rcnt < count($list) ; $rcnt++ ){
			if( $list[$rcnt] != "" &&
				intval($list[$rcnt]) < 1 || 9 < intval($list[$rcnt]) ){
				$msg = $list[$rcnt] . _MD_BBSB_ERROR_BATSCORE2_RBI;
				$this->addErrorMessage($msg);
			}
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}

?>
