<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/**
 * եࡧϿ(MobileϿ)
 */
class BBSB_EditGamedetailMpitForm extends XCube_ActionForm
{
	var	$mMyDirName	= null;		// ⥸塼ǥ쥯ȥ̾
    function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
		require_once XOOPS_MODULE_PATH . "/" . $this->mMyDirName . "/class/DbMember.class.php";
    }

    function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['gid']				= new XCube_IntProperty('gid');				// ID
		$this->mFormProperties['uniformno']			= new XCube_StringArrayProperty('uniformno');	// ֹ
		$this->mFormProperties['throwinning']		= new XCube_IntArrayProperty('throwinning');	// 奤˥󥰿
		$this->mFormProperties['throwout']			= new XCube_IntArrayProperty('throwout');		// 奤˥󥰿(OUT)
		$this->mFormProperties['earnedruns']		= new XCube_IntArrayProperty('earnedruns');	// 
		$this->mFormProperties['runs']				= new XCube_IntArrayProperty('runs');			// 
		$this->mFormProperties['kcnt']				= new XCube_IntArrayProperty('kcnt');			// å
		$this->mFormProperties['bcnt']				= new XCube_IntArrayProperty('bcnt');			// Ϳ͵
		$this->mFormProperties['dbcnt']				= new XCube_IntArrayProperty('dbcnt');			// Ϳ
		$this->mFormProperties['hcnt']				= new XCube_IntArrayProperty('hcnt');			// 
		$this->mFormProperties['hrcnt']				= new XCube_IntArrayProperty('hrcnt');			// 
		$this->mFormProperties['numofpitch']		= new XCube_IntArrayProperty('numofpitch');	// 
		$this->mFormProperties['pitchresult']		= new XCube_StringArrayProperty('pitchresult');// 

		// ID
		$this->mFieldProperties['gid']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['gid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['gid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_GAMEID, "5");
		$this->mFieldProperties['gid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_GAMEID);
		$this->mFieldProperties['gid']->addVar('maxlength', 5);
		$this->mFieldProperties['gid']->addVar('min', '1');
		$this->mFieldProperties['gid']->addVar('max', '32767');
		// ֹ
		$this->mFieldProperties['uniformno']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['uniformno']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['uniformno']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_UNIFORMNO, "5");
		$this->mFieldProperties['uniformno']->addVar('maxlength', 5);
		// 奤˥󥰿
		$this->mFieldProperties['throwinning']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['throwinning']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['throwinning']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCHINNING, "2");
		$this->mFieldProperties['throwinning']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCHINNING);
		$this->mFieldProperties['throwinning']->addVar('maxlength', 2);
		$this->mFieldProperties['throwinning']->addVar('min', '0');
		$this->mFieldProperties['throwinning']->addVar('max', '99');
		// 奤˥󥰿OUT)
		$this->mFieldProperties['throwout']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['throwout']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['throwout']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCHINNING, "1");
		$this->mFieldProperties['throwout']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCHINNING);
		$this->mFieldProperties['throwout']->addVar('maxlength', 1);
		$this->mFieldProperties['throwout']->addVar('min', '0');
		$this->mFieldProperties['throwout']->addVar('max', '2');
		// 
		$this->mFieldProperties['earnedruns']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['earnedruns']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['earnedruns']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_EARNEDRUNS, "5");
		$this->mFieldProperties['earnedruns']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_EARNEDRUNS);
		$this->mFieldProperties['earnedruns']->addVar('maxlength', 5);
		$this->mFieldProperties['earnedruns']->addVar('min', '0');
		$this->mFieldProperties['earnedruns']->addVar('max', '32767');
		// 
		$this->mFieldProperties['runs']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['runs']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['runs']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_RUNS, "5");
		$this->mFieldProperties['runs']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_RUNS);
		$this->mFieldProperties['runs']->addVar('maxlength', 5);
		$this->mFieldProperties['runs']->addVar('min', '0');
		$this->mFieldProperties['runs']->addVar('max', '32767');
		// å
		$this->mFieldProperties['kcnt']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['kcnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['kcnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_KCNT, "5");
		$this->mFieldProperties['kcnt']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_KCNT);
		$this->mFieldProperties['kcnt']->addVar('maxlength', 5);
		$this->mFieldProperties['kcnt']->addVar('min', '0');
		$this->mFieldProperties['kcnt']->addVar('max', '32767');
		// Ϳ͵
		$this->mFieldProperties['bcnt']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['bcnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['bcnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_BCNT, "5");
		$this->mFieldProperties['bcnt']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_BCNT);
		$this->mFieldProperties['bcnt']->addVar('maxlength', 5);
		$this->mFieldProperties['bcnt']->addVar('min', '0');
		$this->mFieldProperties['bcnt']->addVar('max', '32767');
		// Ϳ
		$this->mFieldProperties['dbcnt']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['dbcnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['dbcnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_DBCNT, "5");
		$this->mFieldProperties['dbcnt']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_DBCNT);
		$this->mFieldProperties['dbcnt']->addVar('maxlength', 5);
		$this->mFieldProperties['dbcnt']->addVar('min', '0');
		$this->mFieldProperties['dbcnt']->addVar('max', '32767');
		// 
		$this->mFieldProperties['hcnt']				= new XCube_FieldProperty($this);
		$this->mFieldProperties['hcnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['hcnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_HCNT, "5");
		$this->mFieldProperties['hcnt']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_HCNT);
		$this->mFieldProperties['hcnt']->addVar('maxlength', 5);
		$this->mFieldProperties['hcnt']->addVar('min', '0');
		$this->mFieldProperties['hcnt']->addVar('max', '32767');
		// 
		$this->mFieldProperties['hrcnt']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['hrcnt']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['hrcnt']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_HRCNT, "5");
		$this->mFieldProperties['hrcnt']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_HRCNT);
		$this->mFieldProperties['hrcnt']->addVar('maxlength', 5);
		$this->mFieldProperties['hrcnt']->addVar('min', '0');
		$this->mFieldProperties['hrcnt']->addVar('max', '32767');
		// 
		$this->mFieldProperties['numofpitch']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['numofpitch']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['numofpitch']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PITCH_NUMOFPITCH, "5");
		$this->mFieldProperties['numofpitch']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_PITCH_NUMOFPITCH);
		$this->mFieldProperties['numofpitch']->addVar('maxlength', 5);
		$this->mFieldProperties['numofpitch']->addVar('min', '0');
		$this->mFieldProperties['numofpitch']->addVar('max', '32767');
		// 
		$this->mFieldProperties['pitchresult']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['pitchresult']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['pitchresult']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_WINLOSE, "10");
		$this->mFieldProperties['pitchresult']->addVar('maxlength', 10);

	}

	/**
	 * ֹ ϥå
	 * @return unknown_type
	 *	¸ߤֹ椬ϤƤ뤳
	 */
	function validateUniformNo()
	{
		$mlist = array();
		$mlist = $this->get('uniformno');

		// ¸ߤֹǤ뤳ȡ
		$uid = array();
		$dbM = new BBSB_DbMember($this->mMyDirName);
		for( $rcnt = 0 ; $rcnt < _BBSB_OP_PITCHERS_ROWNUM ; $rcnt++ ){
			if( $mlist[$rcnt] === "" ){ continue; }
			// TODO FIXME :ߤֹηintʤΤʸϤϤ褦ˤ롣DBηstrѹϡ³顼åǤҤäϤ
			if( !is_numeric($mlist[$rcnt]) ){
				 $this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_UNONOTFOUND, $mlist[$rcnt]));
			}
			$dbM->unsetData();
			$dbM->setData( 'UniformNo',	$mlist[$rcnt] );
			$dbM->setOrderBy( 'UserID', 'ASC' );
			$uid = $dbM->getListbyCond('bb_member','UserID', 1);
			if( $uid[0]['UserID'] === null ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_UNONOTFOUND, $mlist[$rcnt]));
			}
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}

?>
