<?php
if (!defined('XOOPS_ROOT_PATH')) exit();
require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/***
 * եࡧ꡼Ͽ
 */
class BBSB_EditLeaguedetailForm extends XCube_ActionForm
{
	var	$mMyDirName	= null;		// ⥸塼ǥ쥯ȥ̾
    function __construct($mydirname) {
		$this->mMyDirName	= $mydirname;
		parent::XCube_ActionForm();
		require_once XOOPS_MODULE_PATH . "/" . $this->mMyDirName . "/class/DbLeague.class.php";
    }

    function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['lid']			= new XCube_IntProperty('lid');			// ꡼ID
		$this->mFormProperties['leaguename']	= new XCube_StringProperty('leaguename');	// ꡼̾
		$this->mFormProperties['url']			= new XCube_StringProperty('url');			// URL
		$this->mFormProperties['syncurl']		= new XCube_StringProperty('syncurl');		// ƱURL

		// ꡼ID
		$this->mFieldProperties['lid']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['lid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['lid']->addMessage('maxlength',			_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_LEAGUEID, "5");
		$this->mFieldProperties['lid']->addMessage('intRange',			_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_LEAGUEID);
		$this->mFieldProperties['lid']->addVar('maxlength', 5);
		$this->mFieldProperties['lid']->addVar('min', '1');
		$this->mFieldProperties['lid']->addVar('max', '32767');
		// ꡼̾(ɬ)
		$this->mFieldProperties['leaguename']	= new XCube_FieldProperty($this);
		$this->mFieldProperties['leaguename']->setDependsByArray(array('required','maxlength'));
		$this->mFieldProperties['leaguename']->addMessage('required',	_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_LEAGUE);
		$this->mFieldProperties['leaguename']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_LEAGUE, '128');
		$this->mFieldProperties['leaguename']->addVar('maxlength', 128);
		// URL
		$this->mFieldProperties['url']			= new XCube_FieldProperty($this);
		$this->mFieldProperties['url']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['url']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,			_MD_BBSB_LANG_URL, '256');
		$this->mFieldProperties['url']->addVar('maxlength', 256);
		// ǡƱURL
		$this->mFieldProperties['syncurl']		= new XCube_FieldProperty($this);
		$this->mFieldProperties['syncurl']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['syncurl']->addMessage('maxlength',_MD_BBSB_ERROR_MAXLENGTH,		_MD_BBSB_LANG_SYNCURL, '256');
		$this->mFieldProperties['syncurl']->addVar('maxlength', 256);
	}

	/**
	 * ꡼̾  ϥå
	 * @return unknown_type
	 *	ϻˡƱ꡼̾Υ쥳ɤäϥ顼
	 */
	function validateLeagueName()
	{
		if( $this->get('lid') ){
			$exarray = array( 'LeagueID' => $this->get('lid') );	// LeagueID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;										// LeagueID̵(=)
		}
		$dbLg = new BBSB_DbLeague($this->mMyDirName);
		$dbLg->setData( 'LeagueName',	$this->get('leaguename') );
		$count = $dbLg->CountNum( 'bb_league', $exarray );
		if( $count != 0 ){
			$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_LEAGUE));
		}
	}

	/**
	 * URL ϥå
	 * @return unknown_type
	 */
	function validateUrl()
	{
		$t_url = $this->get('url');
		if (strlen($t_url) > 0) {
			if (!preg_match('/^https?(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $t_url)) {
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, _MD_BBSB_LANG_URL));
			}
		}
	}

	/**
	 * ƱURL ϥå
	 * @return unknown_type
	 */
	function validateSyncUrl()
	{
		$t_url = $this->get('syncurl');
		if (strlen($t_url) > 0) {
			if (!preg_match('/^https?(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $t_url)) {
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_INJURY, _MD_BBSB_LANG_SYNCURL));
			}
		}
	}

	/**
	 * 
	 * @see core/XCube_ActionForm#load($obj)
	 */
	function load(&$obj)
	{
	}

}
?>
